Changes prefixed with "(*)" are potentially breaking to scripts or existing
repositories (changes that are automatically handled by the format upgrade tools
are not marked). Those prefixed with "(+)" are new command/option (since
2.1.0~alpha2).

2.4.1:
* Fix pin-depends being ignored on simulated pins
  (e.g. `opam install --deps-only`) [#6612 @kit-ty-kate - fix #6610]
* Improve and extend the testsuite [#6612 @kit-ty-kate]

2.4.0:
* Fix a regression in `opam pin list` which crashed when the source of the
  pinned package doesn't exist [#6598 @kit-ty-kate - fix #6600]
* Improve and extend the testsuite [#6598 @kit-ty-kate]

2.4.0~rc1:
* Fix `opam switch <version>` when all compilers of that version are
  flagged with `avoid-version` [#6571 @rjbou - fix #6563]
* Ignore VCS directories when diffing during updates
  [#6575 @kit-ty-kate - fix #6560]
* Opam update performance: No longer copy VCS directories when adding or
  updating local non-VCS repositories [#6575 @kit-ty-kate - fix #6560]
* Do not remove the generated patch file during updates when debug-mode is on
  [#6575 @kit-ty-kate]
* Improve the release script:
  * Switch the host of qemu-base-images from gitlab to github
    [#6510 @kit-ty-kate]
  * Speedup the initial clone of qemu-base-images when missing
    [#6510 @kit-ty-kate]
  * Update some of the platforms the prebuilt binaries are built on to
    Alpine 2.21, FreeBSD 14.3, OpenBSD 7.7 and NetBSD 10.1 [#6510 @kit-ty-kate]
* Build changes:
  * Use coreutils' `sha512sum` instead of perl's `shasum` utility when using
    `./configure --with-cygwin-setup` [#6566 @kit-ty-kate - fix #6557]
  * Upgrade the download-if-missing dependencies to `dune 3.19.1`,
    `opam-file-format 2.2.0`, `spdx_licenses 1.4.0` and `patch 3.0.0`
    [#6580 @kit-ty-kate]
* Improve and extend the testsuite [#6473 #6571 @rjbou @kit-ty-kate]
* Improve and extend the test infrastructure [#6575 @kit-ty-kate]
* API changes in `opam-format`:
  * `OpamLocal`: `fetch_repo_update` no longer copies vcs directories
    [#6575 @kit-ty-kate]
* API changes in `opam-core`:
  * `OpamSystem`: Add `get_files_except_vcs` [#6575 @kit-ty-kate]
  * `OpamSystem`: Add `copy_dir_except_vcs` [#6575 @kit-ty-kate]

2.4.0~beta1:
* Fixed some bugs in `opam install --deps-only` (and other commands
  simulating package pins, such as `--depext-only`) more visible in 2.4:
  * When a package `pkg` is already installed and `opam install ./pkg --deps`
    is called, if there is a conflict between the installed `pkg` dependencies
    and the definition of the local `pkg`, the conflict was not seen and the
    already installed `pkg` was kept [#6530 @rjbou - fix #6529]
  * No longer fetch and write the sources when simulating packages that were
    already pinned [#6533 @rjbou - fix #6532]
  * opam was triggering the reinstall of the package based on the already
    pinned packages instead of the expected newly simulated pinned packages
    [#6522 @rjbou - partial fix #6501]
  * opam was using the opam description of the wrong package in some cases
    [#6544 @kit-ty-kate - fix #6535]
* ◈ Change the behaviour of `--deps-only`, where it no longer requires
  unicity of package version between the request and the installed packages.
  In other words, if you have `pkg.1` installed, installing dependencies of
  `pkg.2` no longer removes `pkg.1`. This also allows to install dependencies
  of conflicting packages when their dependencies are compliant. [#6520 @rjbou]
* Fix a regression where the internal `sources` directory was removed
  unexpectedly on reinstall actions, making opam re-fetch the package
  [#6550 @rjbou - fix #6554]
* Fixed a couple of regressions in `opam update`:
  * An unexpected stack overflow exception was raised when updating
    repositories with large files when opam is compiled with OCaml < 5.1
    [#6527 @kit-ty-kate - fix #6513]
  * Updating a repository where a line was added at the end of a file without
    final newline character was making the update fail
    [#6527 @kit-ty-kate - fix hannesm/patch#28]
* Build changes:
  * Bump the downloaded-if-missing dune to 3.19.0, cppo to 1.8.0,
    ocamlgraph to 2.2.0, uutf to 1.0.4 and patch to 3.0.0~beta1
    [#6527 @kit-ty-kate]
  * Allows `./configure --without-dune` to build with OCaml 5.4
    [#6527 @kit-ty-kate]
  * Add a `--with-cygwin-setup` option to the `configure` script, only
    available on Windows and disabled by default, which includes the
    optionally given `setup-x86_64.exe` binary inside the opam binary.
    If the option is given without a filename, the file with be fetched
    from `cygwin.com` [#6526 @kit-ty-kate @dra27 @rjbou - fix #6498]
* Improve the prebuilt Windows binaries by including Cygwin's
  `setup-x86_64.exe` in the binary itself as fallback, in case `cygwin.com`
  is inaccessible [#6538 @kit-ty-kate]
* Improve and extend the testsuite
  [#6530 #6533 #6539 #6544 #6550 #6520 @rjbou @kit-ty-kate]
* Improve and extend the test infrastructure
  [#6524 #6553 #6549 @kit-ty-kate @rjbou]
* API changes in `opam-client`:
  * `OpamAction.cleanup_artefacts`: no longer removes the internal `sources`
    directory if the package is installed but not pinned [#6550 @rjbou]

2.4.0~alpha2:
* Do not include compiler packages flagged with `avoid-version`/`deprecated`
  in the generated invariant when calling `opam switch create [name] <version>`
  [#6494 @kit-ty-kate]
* Cygwin: Fallback to the existing `setup-x86_64.exe` if its upgrade failed
  to be fetched [#6482 @kit-ty-kate - fix #6495, partial fix #6474]
* Regression fixes from `2.4.0~alpha1`:
  * Fix a crash when updating a repository that is deleting or adding empty
    files [#6490 @kit-ty-kate]
  * Fix an extreme performance issue (takes several hours) when applying a
    large repository update [#6490 @kit-ty-kate]
  * Fix a crash when updating a git repository that moved a file to a new
    directory [#6490 @kit-ty-kate]
* Fix a memory leak happening when running large numbers of commands or
  opening large number of opam files [#6485 @hannesm - fix #6484]
* Remove handling of the `OPAMSTATS` environment variable [#6485 @hannesm]
* Build changes:
  * Update the requirement for the `patch` library to `3.0.0~alpha2`
    [#6490 @kit-ty-kate]
  * Upgrade the downloaded-if-missing `patch` library to `3.0.0~alpha2`
    [#6490 @kit-ty-kate]
* Improve and extend the testsuite [#6490 #6494 @rjbou @kit-ty-kate]
* Improve and extend the test infrastructure [#6277 @rjbou @kit-ty-kate]
* API changes in `opam-client`:
  * `OpamClientConfig`: remove `STATS` variant and related `print_stats`
    field in config record [#6485 @hannesm]
  * `OpamArg.environment_variable`: make `STATS` as removed from cli 2.3
    [#6485 @rjbou]
* API changes in `opam-format`:
  * `OpamFile`: remove `Stats` module [#6485 @hannesm]
* API changes in `opam-core`:
  * `OpamSystem`: remove `print_stats` function [#6485 @hannesm]
  * `OpamSystem`: add the `rmdir_cleanup` function [#6490 @kit-ty-kate]
  * `OpamSystem.dir_is_empty`: Speedup and change its type to handle
    unreachable directories better [#6490 @kit-ty-kate]
  * `OpamSystem.internal_patch`: remove parent directories when all of their
    content has been moved somewhere else [#6490 @kit-ty-kate]
  * `OpamSystem.internal_patch`: fix moving files to new directories when
    receiving a git diff [#6490 @kit-ty-kate]

2.4.0~alpha1:
* (*) Remove `ocaml-system` from the list of default compilers chosen at
  `opam init` time [#6307 @kit-ty-kate - fix #3509]
* (*) Fail when trying to pin a package whose definition could not be found
  instead of forcing interactive edition (e.g. this could happen when
  making a typo in the package name of a pin-depends)
  [#6319 @kit-ty-kate - fix #6322]
* Patches are now applied using the `patch` OCaml library instead of GNU Patch
  [#5892 @kit-ty-kate - fix #6019 #6052]
  * (*) Context diffs are not supported anymore, only Unified diffs are
    (including its git extensions) [#5892 @kit-ty-kate]
  * (*) Stop support of file permission changes via git extension to the
    unified diff specification [#5892 @kit-ty-kate - fix #3782]
* (*) Fix `opam install <local_dir>` not updating and storing pinned
  packages' metadata [#6209 @kit-ty-kate - fix #5567]
* (*) Fix `opam install --deps-only/--show-action <local_dir>` not updating
  (without storing) pinned packages' metadata [#6209 @kit-ty-kate - fix #5567]
* (*) Symlinks in repositories are no longer supported [#5892 @kit-ty-kate]
* (*) Support providing external dependencies with Nix by adding support
  for stateless depexts systems
  [#5982 @RyanGibb @rjbou @kit-ty-kate - fix #5124]
* `opam show` now displays the version number of packages flagged with
  `avoid-version`/`deprecated` gray [#6358 @kit-ty-kate - fix #6354]
* Remove the build directories of pinned packages after successful builds
  [#6436 @kit-ty-kate]
* (*) Fix `pin-depends` for `with-*` dependencies when creating a lock file
  [#5471 @rjbou - fix #5428]
* GNU `patch` and the `diff` command are no longer runtime dependencies
  [#5892 @kit-ty-kate - fix ocaml/setup-ocaml#933 #6052]
* Fix a regression on `opam upgrade <package>` upgrading unrelated packages
  [#6373 @AltGr]
* Fix a regression on `opam upgrade --all <uninstalled-pkg>` not upgrading
  the whole switch [#6373 @kit-ty-kate]
* `opam pin`/`opam pin list` now displays the current revision of a pinned
  repository in a new column [#6274 @desumn - fix #5533]
* Don't ask confirmation when pinning an unknown package
  (absent from repositories) [#6309 @kit-ty-kate @rjbou - fix #3199]
* Do not show the not-up-to-date message with packages tagged with
  `avoid-version`/`deprecated` [#6273 @kit-ty-kate - fix #6271]
* (*) Disable the detection of available system packages on SUSE-based
  distributions [#6464 @kit-ty-kate]
* Allow running some opam commands on machines with limited amount of memory
  by running `Gc.compact` while the main process is waiting for the children
  processes [#5396 @kkeundotnet]
* Prefer curl over any other download tools on every systems,
  if available [#6305 @kit-ty-kate]
* Add the `OPAMSOLVERTOLERANCE` environment variable to allow users to fix
  solver timeouts for good [#5510 @kit-ty-kate - fix #3230]
* Add `fetch` on DragonFlyBSD and `ftp` on NetBSD to the list of download
  tools to use, if available [#6305 @kit-ty-kate]
* Fix the detection of `ZDOTDIR` when using `zsh`
  [#6299 @acasta-yhliu - fix #6281]
* Check that the repositories given to `opam repository remove` actually
  exist [#5014 @kit-ty-kate - fixes #5012]
* Respect the `DUNE_CACHE_ROOT` environment variable if it exists
  [#6326 @smorimoto]
* (+) Add `opam admin compare-versions` to compare package versions for
  sanity checks [#6197 @mbarbin]
* Fix `opam admin check` in the presence of the `with-dev-setup` variable
  [#6331 @kit-ty-kate - fix #6329]
* (*) The `-i`/`--ignore-test-doc` argument has been removed from
  `opam admin check` [#6335 @kit-ty-kate]
* (*) `opam admin check` now sets `with-test` and `with-doc` to `false`
  instead of `true` [#6335 @kit-ty-kate]
* (+) Add `opam admin migrate-extrafiles` which moves all `extra-files`
  of an existing opam repository into `extra-sources`
  [#5960 @hannesm @rjbou @kit-ty-kate]
* Fix `opam switch remove <dir>` failure when it is a linked switch
  [#6276 @btjorge - fix #6275]
* (*) Ensure the right version (the pinned one) of packages are used when
  simulating pinning [#6256 @rjbou @kit-ty-kate - fix #6248 #6379]
* Fix sandboxing support on NixOS [#6333 @kit-ty-kate]
* Improve the messages when a package is not up-to-date on `opam upgrade`
  [#6272 @kit-ty-kate - fix #6270]
* Use a non-underline uppercase character to denote the default when
  asking a question [#6289 @hannesm @kit-ty-kate - fix #6288]
* Fix the detection of installed external packages on OpenBSD to not just
  consider manually installed packages [#6362 @semarie]
* Do not pre-write the answer to questions with the default anwser
  [#6376 @kit-ty-kate]
* (+) Add `opam lock --keep-local` to keep local pins url in `pin-depends`
  field [#6411 @rjbou - fix #4897]
* Do not ask to install `pin-depends` twice [#6375 @kit-ty-kate - fix #6374]
* Correctly handle `pkg.version` pattern in `opam switch list-available`
  [#6186 @arozovyk - fix #6152]
* Fix `opam switch list-available` when given several arguments
  [#6318 @kit-ty-kate]
* Avoid issues when using `wget2` as download-tool where the requested url
  might return an HTML page instead of the expected content
  [#6303 @kit-ty-kate]
* Speedup the detection of available system packages with `pacman` and `brew`
  [#6324 @kit-ty-kate]
* (+) Add `--require-checksums` and `--no-checksums` to `opam source`
  [#5563 @rjbou]
* Add `apt-rpm`/ALTLinux family support for depexts [#6207 @RiderALT]
* Display Windows `NTSTATUS` exit codes in hex [#6401 @dra27 @MisterDA]
* Use a C stub to call the `uname` function from the C standard library
  instead of calling the `uname` POSIX command [#6217 @kit-ty-kate]
* Don't write empty environment update segments to `variables.sh`
  (`FOO += ""` no longer adds `FOO='':"$FOO"; export FOO;`) [#6198 @dra27]
* Only download Cygwin's `setup.exe` when the command is actually going
  to be displayed or used [#6467 @kit-ty-kate]
* Add W74 to `opam lint` to detect `pin-depends` packages that are neither
  present in the `depends` no `depopts` field [#6317 @rjbou - fix #5795]
* Add E63 to `opam lint` to check for availability guard in case an opam
  file contains a `subpath` field [#6438 @rjbou @kit-ty-kate]
* Add `--cli`/`OPAMCLI` version 2.4 [#6268 @mbarbin @rjbou]
* Fix `subpath` handling in opam files defining a local archive
  [#6439 @rjbou]
* Change probing tool for SUSE-based distributions from `zypper` to `rpm`
  [#6464 @kit-ty-kate]
* Build changes:
  * Simplify the making of stripped binaries by introducing the
    `make opam-stripped` target [#6208 @kit-ty-kate]
  * Fix compilation on macOS with OCaml 5.3 by bumping the
    downloaded-if-missing `mccs` to 1.1+19 [#6192 @kit-ty-kate]
  * Upgrade the downloaded-if-missing `opam-file-format` to 2.2.0~alpha1,
    `spdx_licenses` to 1.3.0 and `dune` to 3.16.1
    [#6321 #6370 #6192 @kit-ty-kate - fix #6369]
  * `menhir` is now part of the transitive dependency of opam
    (via `opam-file-format`) [#6321 @kit-ty-kate]
* Accurately tag `curl` download command when loaded from global config file
  [#6302 @rjbou]
* Remove `wget` support for Software Heritage fallback
  [#6036 @rjbou - fix #5721]
* Fix Software Heritage liveness check [#6036 @rjbou - fix #5721]
* Update the Software Heritage API requests [#6036 @rjbou]
* Improve and extend the tests
  [#5892 #6276 #6331 #6343 #6378 #6273 #6380 #6373 #6307 #6256 #6412 #6438
   #6439 #6436 #6166 #6209 #6209 #6209 #6198 #6319 #6467 #5643 #5982
   @rjbou @kit-ty-kate @btjorge]
* Improve and extend the benchmarks [#6212 #6212 #6443 @kit-ty-kate]
* Improve and extend the test infrastructure
  [#5349 #6296 #6274 #6313 #6363 #6363 #6192 #6192 #5663 #6383 #6444 #6447
   #6471 #6471 #6471 #6471 #6471 #6469 #5982
   @kit-ty-kate @rjbou @RyanGibb]
* Improve and extend the documentation
  [#6226 #6231 #6252 #6252 #6150 #6150 #6150 #6150 #6267 #6251 #6306 #6315
   #5659 #6320 #6338 #6361 #6358 #5627 #6372 #6470
   @kit-ty-kate @rjbou @RyanGibb @gridbugs @fccm2 @shym
   @hannesm @tobil4sk @juergenhoetzel @MisterDA]
* API changes in `opam-client`:
  * `OpamAction.prepare_package_build`: now returns `exn option` instead of
    `exn option OpamProcess.job` and no longer calls the system GNU Patch
    [#5892 @kit-ty-kate]
  * `OpamArg.InvalidCLI`: export exception [#6150 @rjbou]
  * `OpamArg`: export `require_checksums` and `no_checksums`, that are shared
    with `build_options` [#5563 @rjbou]
  * `OpamArg.hash_kinds`: was added [#5960 @kit-ty-kate]
  * `OpamAuxCommands.{simulate_autopin,autopin ~simulate:true}`: now updates
    the `reinstall` field of the returned `switch_state` if necessary
    [#6209 @kit-ty-kate]
  * `OpamRepositoryCommand.switch_repos`: expose the function
    [#5014 @kit-ty-kate]
  * `OpamLockCommand.lock_opam`: add `~keep_local` argument to add local pins
    to pin-depends (and not resolve them) [#6411 @rjbou]
  * `OpamLockCommand.lock_opam`: make the `?only_direct` argument non-optional
    [#6411 @kit-ty-kate]
  * `OpamSolution.print_depext_msg`: takes now an `OpamSysPkg.status` instead
    of sets [#5982 @kit-ty-kate @RyanGibb]
  * `OpamSolution.install_sys_packages`: no longer takes set of package to
    install but `OpamSysPkg.to_install` [#5982 @rjbou @RyanGibb @kit-ty-kate]
  * `OpamSolution.install_depexts`: instead of the package set of new package
    to install, now takes 2 labelled arguments `pkg_to_install` and
    `pkg_installed` to be able to keep synchronised stateless depext systems
    [#5982 @rjbou @RyanGibb @kit-ty-kate]
* API changes in `opam-repository`:
  * `OpamDownload.get_output`: fix `wget` option for `POST` requests
    [#6036 @rjbou]
  * `OpamDownload.get_output`: use long form for `curl` `POST` request option
    [#6036 @rjbou]
  * `OpamDownload.download`: more fine grained HTTP request error code
    detection for curl [#6036 @rjbou]
  * `OpamLocal.pull_url`: fix subpath handling when the url is a local archive
    [#6439 @rjbou]
  * `OpamRepository.revision`: now returns a `string` instead of a `version`
    [#6409 @kit-ty-kate]
  * `OpamRepositoryBackend.S.revision`: now returns a `string` instead of a
    `version` [#6409 @kit-ty-kate]
  * `OpamRepositoryBackend.get_diff`: now returns `exn option` instead of
    `exn option OpamProcess.job` and no longer calls the system `diff`
    utility [#5892 @kit-ty-kate]
  * `OpamRepositoryBackend.get_diff`: now raises `Stdlib.Failure` if an
    unsupported file type or comparison is detected [#5892 @kit-ty-kate]
* API changes in `opam-state`:
  * `OpamStateConfig`: Make the `?lock_kind` parameters non-optional to avoid
    breaking the library users after they upgrade their opam root
    [#5488 @kit-ty-kate]
  * `OpamSwitchState.load_selections`: Make the `?lock_kind` parameter
    non-optional to avoid breaking the library users after they upgrade their
    opam root [#5488 @kit-ty-kate]
  * `OpamSysInteract.Cygwin.check_setup`: unexpose the function
    [#6467 @kit-ty-kate]
  * `OpamSysInteract.package_status`: SUSE-based distributions now uses `rpm`
    instead of `zypper` and no longer return an `available` set of system
    packages [#6464 @kit-ty-kate]
  * `OpamSysInteract.packages_status`: returns now a `OpamSysPkg.status`
    instead of sets [#5982 @kit-ty-kate @RyanGib]
  * `OpamSysInteract.{install_packages_commands,install}: no longer takes set
    of package to install but `OpamSysPkg.to_install`
    [#5982 @rjbou @RyanGibb @kit-ty-kate]
  * `OpamSysInteract.package_manager_name`: no longer build the command, or
    run an action to retrieve system package manager name [#5982 @rjbou]
  * `OpamSysInteract`: add `stateless_install` that return if system package
    manager is stateless one (per switch) [#5982 @rjbou]
  * `OpamSysInteract.{install_packages_commands,install}: takes a new
    argument, a switch stat option, for stateless systems that need to write
    on switch [#5982 @RyanGibb @rjbou]
* API changes in `opam-format`:
  * `OpamFormula.string_of_relop`: export function [#6197 @mbarbin]
  * `OpamFormula.all_relop`: a list of all operators [#6197 @mbarbin]
  * `OpamFile.OPAM.{*read*,write*}`: Stop modifying the `available` field
    when handling the builtin `x-*` fields [#6438 @kit-ty-kate]
  * `OpamFile.Repos_config.t`: change the type to not allow repositories
    without an URL [#6249 @kit-ty-kate]
  * `OpamPath`: add `nix_env` inner switch path for nix environment
    [#5982 @RyanGibb]
  * `OpamSysPkg`; add new type `to_install` to store system package to
    install information, newly requested ones and already installed
    required ones ; and its empty recode `to_install_empty` and display
    function `string_of_to_install` [#5982 @rjbou]
* API changes in `opam-core`:
  * `OpamConsole`: Replace `black` text style (unused and not very readable)
    by `gray` [#6358 @kit-ty-kate]
  * `OpamConsole.pause`: Ensure the function always prints a newline character
    at the end [#6376 @kit-ty-kate]
  * `OpamFilename.patch`: now returns `exn option` instead of
    `exn option OpamProcess.job` and no longer calls the system GNU Patch
    [#5892 @kit-ty-kate]
  * `OpamFilename.patch`: a named-parameter `~allow_unclean` was added
    [#5892 @kit-ty-kate]
  * `OpamHash.all_kinds`: was added, which returns the list of all possible
    values of `OpamHash.kind` [#5960 @kit-ty-kate]
  * `OpamParallel.*.{map,reduce,iter}`: Run `Gc.compact` when the main
    process is waiting for the children processes for the first time
    [#5396 @kkeundotnet]
  * `OpamStd.List.split`: Improve performance [#6210 @kit-ty-kate]
  * `OpamStd.Option.equal_some`: was added, which tests equality of an option
    with a value [#6381 @kit-ty-kate]
  * `OpamStd.Sys.getconf`: was removed, replaced by `get_long_bit`
    [#6217 @kit-ty-kate]
  * `OpamStd.Sys.get_long_bit`: was added, which returns the output of the
    `getconf LONG_BIT` command [#6217 @kit-ty-kate]
  * `OpamStd.Sys.uname`: now returns the memoized result of the `uname`
    function from the C standard library [#6217 @kit-ty-kate]
  * `OpamStd.Sys.get_freebsd_version`: was added, which returns the output
    of the `uname -U` command [#6217 @kit-ty-kate]
  * `OpamSystem.get_files`: was exposed which returns the list of files
    (without prefix) inside the given directory [#5892 @kit-ty-kate]
  * `OpamSystem.remove_dir`: do not fail with an exception when directory
    is a symbolic link [#6276 @btjorge @rjbou - fix #6275]
  * `OpamSystem.patch`: now returns `exn option` instead of
    `exn option OpamProcess.job` and no longer calls the system GNU Patch
    [#5892 @kit-ty-kate]
  * `OpamSystem.patch`: a named-parameter `~allow_unclean` was added
    [#5892 @kit-ty-kate]
  * `OpamSystem.patch`: do not remove the original patch file if called with
    `~preprocess:false` [#5892 @kit-ty-kate]
  * `OpamSystem`, `OpamFilename`: add `with_tmp_file` and `with_tmp_file_job`
    function, that create a file name in temporary directory and removes it
    at the end of the call [#6036 @rjbou]

2.3.0:
* (no difference compared to 2.3.0~rc1)

2.3.0~rc1:
* Improve the release script by adding a NetBSD/x86_64 binary
  [#6258 @kit-ty-kate]

2.3.0~beta2:
* Fix the detection of the current terminal size
  [#6244 @kit-ty-kate - fix #6243]
* Improve the release script by upgrading the platform building the Linux
  binaries to Alpine 3.20, the FreeBSD binary to FreeBSD 14.1 and the
  OpenBSD binary to OpenBSD 7.6 [#6237 @kit-ty-kate]
* Make the release script produce a Linux/riscv64 binary [#6237 @kit-ty-kate]
* API changes
  * `OpamStubs.get_stdout_ws_col`: new Unix-only function returning the
    number of columns of the current terminal window [#6244 @kit-ty-kate]

2.3.0~beta1:
* Fix an opam 2.1 regression where the initial pin of a local VCS directory
  would store untracked and ignored files. Those files would usually be
  cleaned before building the package, however git submodules would not be
  cleaned and would cause issues when paired with the new behaviour added in
  2.3.0~alpha1 which makes opam error when git submodules fail to update
  (was previously a warning) [#6221 @rjbou - fix #5809]
* Fix a regression which would make opam crash on platforms where
  `getconf LONG_BIT` is not available (e.g. OpenBSD)
  [#6230 @kit-ty-kate - fix #6215]
* Fix the installed packages internal cache, which was storing the wrong
  version of the opam file after a build failure. This could be triggered
  easily for users with custom repositories with non-populated extra-files
  [#6213 @kit-ty-kate]
* Fix a regression in lint W59 with local urls that are not archives
  [#6219 @rjbou - fix #6218]
* Bump to lang dune to 2.8 and bump the requirement to dune >= 2.8, which was
  actually required in the previous alpha release [#6204 @kit-ty-kate]
* Bump the vendored version of dune to 3.16.0, cppo to 1.7.0 and extlib to 1.8.0
  [#6223 @kit-ty-kate]
* Fix compilation with OCaml 5.3 when using the vendored extlib by updating to
  the 5.3 compatible version [#6223 @kit-ty-kate]
* Fix the compilation of opam on Windows with OCaml >= 5.0 (again)
  [#6216 @kit-ty-kate]
* Fix the release script after the bump to dune lang 2.6 and the introduction of
  `opam_core_stubs` [#6204 @kit-ty-kate]
* Improve the release script by ignoring interactive questions asked by the
  FreeBSD package manager [#6204 @kit-ty-kate]
* Improve and extend the tests [#6135 #6221 #6213 #6219 @rjbou]
* Improve the test infrastructure [#6233 #6233 #6216 @rjbou @kit-ty-kate]
* API changes
  * `OpamStd.Sys.{get_terminal_columns,uname,getconf,guess_shell_compat}`:
    Harden the process calls to account for failures
    [#6230 @kit-ty-kate - fix #6215]
  * `OpamStd.Sys.{uname,getconf}`: now accepts only one argument as parameter,
    as per their documentation [#6230 @kit-ty-kate]
  * `OpamSwitchState.Installed_cache`: export `load` function [#6233 @rjbou]
  * `OpamSystem`: add `is_archive_from_string` that does the same than
    `is_archive` but without looking at the file, only analysing the string
    (extension) [#6219 @rjbou]

2.3.0~alpha1:
* (*) When loading a repository, don't automatically populate `extra-files:`
  field with found files in `files/` [#5564 @rjbou]
* Fix most unhelpful conflict explanation message by merging all formulas
  together [#6106 @kit-ty-kate]
* Silently mark packages requiring an unsupported version of opam as unavailable
  [#5665 @kit-ty-kate - fix #5631]
* Fix Windows builds with OCaml >= 5.0 [#6189 @kit-ty-kate - fix #6148]
* (+) Add a new `opam list --latests-only` option to only list the latest
  packages [#5375 @kit-ty-kate]
* (*) opam switch list-available will not display compilers flagged with
  avoid-version/deprecated unless --all is given
  [#6098 @kit-ty-kate - fix #6089]
* (*) Fix `opam install --check pkg` when pkg depends on a non-existing package
  [#6121 @kit-ty-kate]
* (*) Make `opam install --check` check if all dependencies are installed
  recursively [#6122 @kit-ty-kate - fix #6097]
* (+) Add the `--verbose-on` option to enable verbose mode on specified package
  names [#5682 @desumn @rjbou]
* (+) Add `opam switch import --deps-only` option to install only dependencies
  of root package at import [#5388 @rjbou - fix #5200]
* Always list all the repositories with `opam config report` regardless of
  whether or not a switch is currently set [#6116 @kit-ty-kate]
* Add support for wget2 [#6104 @kit-ty-kate]
* (*) Make accepted `--repos` URLs on creation consistent with `opam repository`
  [#6091 @Keryan-dev - fix #4673]
* (*) Fix the value of the 'arch' variable when the current OS is 32bit on a
  64bit machine [#5950 @kit-ty-kate - fix #5949]
* Fix package names displayed on conflicts [#6055 @rjbou - fix #6030]
* Improve the error message when a directory is not available while fetching
  using rsync [#6027 @kit-ty-kate]
* (*) Fail when git submodule fails to update instead of showing a warning and
  ignoring the error [#6132 @kit-ty-kate - fix #6131]
* Suppress all the Windows menus when running with `opam init -ya`
  [#6034 @dra27]
* Improvements to the `builtin-0install` solver:
  * Add support for unordered criteria [#6130 @kit-ty-kate]
  * Add support for the `-changed` criteria to make the solver prefer to keep
    packages installed at their current version [#6130 @kit-ty-kate]
  * Add support for the `-count[avoid-version,solution]` criteria to avoid
    packages marked with `avoid-version` flag [#6130 @kit-ty-kate]
  * The default criteria changed from empty to
    `-changed,-count[avoid-version,solution]` [#6130 @kit-ty-kate]
  * The upgrade and fixup criteria changed from empty to
    `-count[avoid-version,solution]` [#6130 @kit-ty-kate]
* Fix apt/debian lookup for installed packages [#6054 @rjbou]
* Make `opam config report` return the actual invariant syntax expected by
  `--invariant` [#5619 @kit-ty-kate - fixes #5491]
* (*) Make `opam switch set-invariant` return the actual invariant syntax
  expected by `--invariant` [#5619 @kit-ty-kate - fixes #5491]
* Make fetching an archive from cache add missing symlinks
  [#6068 @kit-ty-kate - fix #6064]
* Performance improvements:
  * Stop using polymorphic comparison when comparing
    `OpamTypes.switch_selections` [#6102 @kit-ty-kate]
  * Improve performance of `opam install --check` [#6122 @kit-ty-kate]
  * Reduce allocations in `OpamVersionCompare` [#6144 @talex5]
  * Speedup `OpamVersionCompare` by 25% by removing the unused handling of epoch
    [#5518 @kit-ty-kate]
  * Speedup `opam list` on options that do not use availibility information
    [#5317 @kit-ty-kate - fix #5314]
* Make all writes atomic [#5489 @kit-ty-kate]
* Warn when setting a variable if an option is shadowed
  [#4904 @rjbou - fix #4730]
* Changes and improvements to `opam lint`:
  * Add E70 to check `extra-files:` duplicated fields [#5561 @rjbou]
  * Add E71 to check if the same checksum algorithm is used several times for a
    given url in `url` section [#5561 @rjbou]
  * Add E72 to check if the same checksum algorithm is used several times for a
    given url in `extra-sources` section [#5561 @rjbou]
  * Add E73 to check that paths in `extra-files:` are not escapable
    [#5561 @rjbou]
  * Update W59 (no checksum in `url`) to always display a warning, untying it
    from `--check-upstream` [#5561 @rjbou]
* Changes and improvements to the compilation of opam itself:
  * Unset `OPAM_SWITCH_PREFIX` when using `make cold` [#5534 @kit-ty-kate]
  * Bump the vendored opam-0install-cudf to 0.5.0 [#6130 @kit-ty-kate]
  * Require opam-0install-cudf >= 0.5.0 [#6130 @kit-ty-kate]
  * Bump the vendored mccs to 1.1+18 [#6170 @kit-ty-kate]
  * Upgrade the minimum required version for dune from 2.0.0 to 2.6.0
    [#5381 @dra27]
  * Remove `--with-acl` option from the configure script and its related C stubs
    (reverts a Cygwin fix in #4265) [#5381 @kit-ty-kate - fix #5373]
* Make the shell environment update hint easier to copy/paste
  [#6159 @kit-ty-kate - fix #6158]
* Remove unnecessary copies/move when fetching archives
  [#5018 @kit-ty-kate @rjbou]
* (*) Change the default cache location of `opam admin add-hashes` from
  `~/.cache` to `<opamroot>/download-cache/hash-cache` [#6103 @rjbou]
* Make `opam admin cache` add missing symlinks [#6068 @kit-ty-kate - fix #6064]
* Add install.exe to the list of non-shadowed programs when adding Cygwin's bin
  directory to PATH (ocamlfind et al can be affected by Vim for Windows)
  [#6190 @dra27]
* Propagate future opamfile parse errors correctly [#6199 @dra27]
* Ensure future syntax errors are only reported when the syntax version is
  greater than the client, not the format library [#6199 @dra27 - fix #6188]
* Always pass `--no-version-check` and `--no-write-registry` to Cygwin setup
  [#6046 @dra27]
* Use `--quiet-mode noinput` for the internal Cygwin installation (which is
  definitely a fully-specified command line) and `--quiet-mode unattended` for
  external Cygwin installations (in case the user does need to select something,
  e.g. a mirror) [#6046 @dra27]
* Add cli version 2.3 [#6045 #6151 @rjbou]
* Provide a shell/install.ps1 PowerShell script to install opam on Windows
  [#5906 @kit-ty-kate @dra27]
* Fix opam unable to find executables on systems where users belong to more than
  32 groups when opam is built using musl libc
  [#5381 #6200 @kit-ty-kate @dra27 - fix #5373]
* Allow patches to be applied regardless of CRLF or LF line ending
  [#6182 @dra27]
* Internal changes:
  * Move Windows stubs to opam-core [#5381 @dra27]
  * Remove the meta opam packages opam and opam-admin [#6115 @kit-ty-kate]
* Improve and extend the tests
  [#6045 #6045 #5989 #6055 #5642 #5327 #6103 #6068 #5377 #5474 #5682 #6125 #6121
   #6139 #5375 #6105 #6146 #6098 #6132 #6122 #5561 #6106 #6199
   @rjbou @kit-ty-kate @dra27 @Keryan-dev @madroach]
* Improve the benchmarks [#6094 #6078 #6123 #6149 @kit-ty-kate]
* Improve the test infrastructure
  [#6105 #6155 #6184 #5564 #6079 #6081 #6132 #6074
   @rjbou @kit-ty-kate @Keryan-dev @RyanGibb]
* Improve the documentation
  [#5988 #5946 #6119 #6138 #6141 #5363
   @kit-ty-kate @rjbou @mbarbin @shonfeder]
* API changes
  * `OpamACL`: remove module [#5381 @kit-ty-kate]
  * `OpamArg.build_options`: add `--verbose-on` flag [#5682 @desumn @rjbou]
  * `OpamClientConfig.build_options`: add `verbose_on` field [#5682 @desumn]
  * `OpamClientConfig.E`, `OpamArg.environment_variables`: and `OPAMVERBOSEON`
    support [#5682 @desumn @rjbou]
  * `OpamCudfCriteria`, `OpamBuiltinZ3.Syntax`: Move `OpamBuiltinZ3.Syntax`
    into a dedicated module `OpamCudfCriteria` [#6130 @kit-ty-kate]
  * `OpamFilename`: add `might_escape` to check if a path is escapable, ie
    contains `<sep>..<sep>` [#5561 @rjbou]
  * `OpamFileTools`: `read_opam` & `read_repo_opam` stop adding non registered
    extra-files [#5564 @rjbou]
  * `OpamFileTools.add_aux_files`: ignore non registered extra-files and make
    the `files_subdir_hashes` argument optional (defaults to `false`)
    [#5564 @rjbou]
  * `OpamFormula`: add some missing comparison functions for `relop`,
    `version_constraint` and `atom` (`compare_relop`,
    `compare_version_constraint` and `compare_atom` respectively)
    [#6122 @kit-ty-kate]
  * `OpamFormula`: add `exists` [#5317 @kit-ty-kate]
  * `OpamGit.fetch ?full_fetch` is now `true` by default instead of `false`
    [#6146 @kit-ty-kate - fix #6145]
  * `OpamHash`: export `compare_kind` [#5561 @rjbou]
  * `OpamListCommand.selector`: Add `NotFlag` selector [#6098 @kit-ty-kate]
  * `OpamRepository.fetch_from_cache`: when an archive is found, add a symlink
    (or copy) for the ones found in opam file but not in cache
    [#6068 @kit-ty-kate]
  * `OpamStateConfig.opamroot_with_provenance`: restore previous behaviour to
    `OpamStateConfig.opamroot` for compatibility with third party code
    [#6047 @dra27]
  * `OpamSolver.dependency_graph`: make `unavailable` a non-optional argument to
    enforce speedups when availability information is not needed
    [#5317 @kit-ty-kate]
  * `OpamTypes.universe`: make `u_available` and `u_attrs` lazy to speedup
    actions that do not require availiblity information
    [#5317 @kit-ty-kate - fix #5314]
  * `OpamTypesBase.switch_selections_{compare,equal}`: Add proper comparison
    functions for `OpamTypes.switch_selections` [#6102 @kit-ty-kate]
  * `OpamStd.Env`: add `env_string_list` for parsing string list environment
    variables (comma separated) [#5682 @desumn]
  * `OpamStd.Sys.getconf`: add a function to call the `getconf` command
    [#5950 @kit-ty-kate]
  * `OpamStd.Sys.resolve_command`: Fix opam unable to find executables on
    systems where users belong to more than 32 groups when opam is built using
    musl libc [#5381 @kit-ty-kate - fix #5373]
  * `OpamSwitchCommand.import`: add optional `?deps_only` argument to install
    only dependencies of root packages [#5388 @rjbou]
  * `OpamSwitchState.{,reverse_}dependencies`: make `unavailable` a non-optional
    argument to enforce speedups when availability information is not needed
    [#5317 @kit-ty-kate]

2.2.1:
* (*) Fix a regression in `opam install --deps-only` where the direct
  dependencies were not set as root packages [#6125 @rjbou]
* (*) Fix a regression when fetching git packages where the resulting git
  repository could lead to unexpected outputs of git commands, by disabling
  shallow clone by default except when fetching an opam repositories
  [#6146 @kit-ty-kate - fix #6145]
* Mitigate curl/curl#13845 by falling back from `--write-out` to `--fail`
  if exit code 43 is returned by curl [#6168 @dra27 - fix #6120]
* Synchronise opam-core.opam with opam-repository changes [#6043 @dra27]
* Fix and improve the release script and the creation of the
  `opam-full-<version>.tar.gz` archive [#6067 @kit-ty-kate]
* Improve and extend the tests [#6125 #6146 @rjbou]
* Improve the test infrastructure [#6079 #6081 @rjbou]
* API changes
  * `?full_fetch` is now `true` by default instead of `false`
    [#6146 @kit-ty-kate - fix #6145]

2.2.0:
* Bump `opam-root-version` to 2.2 [#5980 @kit-ty-kate]
* Cygwin initialisation enhancement
  * Always pass `--no-version-check` and `--no-write-registry` to Cygwin setup
    [#6046 @dra27]
  * Use `--quiet-mode noinput` for the internal Cygwin installation (which is
    definitely a fully-specified command line) and `--quiet-mode` unattended
    for external Cygwin installations (in case the user does need to select
    something, e.g. a mirror) [#6046 @dra27]
* API changes
  * `OpamStateConfig.opamroot_with_provenance`: restore previous behaviour to
    `OpamStateConfig.opamroot` for compatibility with third party code
    [#6047 @dra27]

2.2.0~rc1:
* Fix `opam upgrade` wanting to recompile opam files containing the
  `x-env-path-rewrite` field [#6029 @kit-ty-kate - fix #6028]
* Provide defaults so `opam init -y` no longer asks questions
  [#6033 @dra27 - fix #6013]
* Fix OpamConsole.menu > 9 options [#6026 @kit-ty-kate]
* Fix the lower-bound constraint on ocaml-re
  (bump from >= 1.9.0 to >= 1.10.0) [#6016 @kit-ty-kate]
* Update source file location as caml.inria.fr is unavailable
  [#6032 #5789 @mtelvers @kit-ty-kate]
* Fix a wrong use of `OpamFilename.of_string` [#6024 @kit-ty-kate]
* Add Windows to opam's release script [#5789 @kit-ty-kate]
* Improve and extend the tests [#6029 @kit-ty-kate]
* API changes:
  * `OpamTypesBase`: Add `nullify_pos_map` and `nullify_pos_value`
    [#6029 @kit-ty-kate]

2.2.0~beta3:
* (+) New option `opam init --cygwin-extra-packages=CYGWIN_PKGS
  --cygwin-internal-install`, to specify additional packages for internal Cygwin
  [#5930, #5964 @moyodiallo - fix #5834]
* Overhaul Windows `opam init` to determine Unix and Git configuration
  simultaneously, and to detect from Cygwin, Git and MSYS2 from all the known
  package managers and shells [#6000 @dra27]
* Redirect the opam root to `C:\opamroot\opam-xxx` when the opam root contains
  spaces on Windows [#5457 @rjbou @dra27]
* Out-of-the-box UTF-8 paged `--help` on Windows [#5970 @kit-ty-kate]
* Sereval fixes were done related to environment reverting:
  * Fix reverting of environment variables, principally on Windows
    [#5935 @dra27 fix #5838]
  * Fix splitting environment variables [#5935 @dra27]
  * When opam creates an empty variable then appends/prepends a value, ensure
    no additional separator is added [#5935 @dra27 - fix #5925]
  * Fix `x-env-path-rewrite` splitting of values when reverting
    [#5935 @dra27 - fix #5838]
  * Rework the logic of := and =: so that an empty entry is correctly preserved
    on multiple updates [#5935 @dra27 - fix #5926]
  * Fix incorrect reverting of `=+` and `=:` [#5935 @dra27 - fix #5926]
* Fix a performance regression when calling `opam install --deps-only` on an
  already installed package [#5908 @kit-ty-kate - fix #5817]
* Fixed some issues that could appear when upgrading from previous versions of
  opam:
  * Handle init OCaml `sys-ocaml-*` eval variables during format upgrade from
    2.0 -> 2.1 -> 2.2 [#5829 @dra27]
  * Reset the "jobs" config variable when upgrading from opam 2.1 to 2.2,
    instead of 2.0 to 2.1 [#5904 @kit-ty-kate - fix #5816]
* Fixes various issues with opam tree and opam why:
  * Fix `opam tree --with-*` assigning the `with-*` variables to unrequested
    packages [#5919 @kit-ty-kate @rjbou - fix #5755]
  * Fix combinations of `opam tree --with-*` and `--no-switch`
    [#5919 @kit-ty-kate @rjbou - fix #5920]
* Allow to parse opam 2.1 switch import files containing extra-files
  [#5943 @kit-ty-kate - fix #5941]
* Fix download URLs containing invalid characters on Windows
  (e.g. the ? character in `?full_index=1`) [#5921 @dra27]
* Fix extraction of tarballs on Windows which contain symlinks both when those
  symlinks can't be created or if they point to files which don't exist
  [#5953 @dra27]
* Stop hiding the Windows specific arguments of opam init on non-Windows
  platforms [#6003 @rjbou @kit-ty-kate @dra27]
* Various fixes for Windows:
  * Harden the CRLF stripping when using cygcheck [#5993 @dra27]
  * Fix curl failures - the progress meter can become interleaved with the
    status code on Windows [#5984 @dra27 @kit-ty-kate @rjbou]
  * Improve the Git-for-Windows menu shown during opam init
    [#5963 @dra27 - fix #5835]
  * For the `Cygwin` internal operator, don't allow `make.exe` to become
    shadowed [#5996 @dra27]
  * Fix incorrect quoting rule for `MANPATH` [#5972 @dra27]
  * Do not special case the rewriting rule for the PKG_CONFIG_PATH environment
    variable [#6002 @kit-ty-kate - fix #5923]
  * Pass --symlink-type native to Cygwin setup if symlinks are available
    [#5830 @dra27]
  * Pass --no-version-check to Cygwin setup (suppresses a message box if setup
    needs updating) [#5830 @dra27]
  * Pass --quiet-mode noinput to stop the user interrupting the setup GUI
    [#5830 @dra27]
  * Always pass --no-write-registry to the Cygwin installer, not just on first
    installation [#5995 @dra27]
  * Fail if `--git-location` points to a directory not containing git
    [#6000 @dra27]
  * os-distribution is now by default calculated from cygpath for Cygwin and
    MSYS2, instead of needing to be set by opam init [#6000 @dra27]
  * Cygwin setup is now always downloaded and updated both for internal and
    external Cygwin installations [#6000 @dra27]
* Display extractions in the status bar [#5977 @dra27]
* Display a note when reloading a repository [#5977 @kit-ty-kate]
* Various other fixes:
  * Fix rounding error when displaying the timestamp in debug mode
    [#5912 @kit-ty-kate - fix #5910]
  * Relaxed warning 41 in opam lint to not trigger on uses of package variables
    which are guarded by a package:installed filter [#5927 @dra27]
  * Move last-env `OPAM_LAST_ENV` files outside the switch to be in `$OPAMROOT`
    [#5962 @moyodiallo - fix #5823]
  * Fix a typo in the variable description returned by "opam var" [#5961 @jmid]
  * (*) Display lock hold/release messages on stderr instead of stdout
    [#5999 @kit-ty-kate - fix #5990]
  * Stop triggering "Undefined filter variable variable" debug warning for
    `?variable` [#5983 @dra27]
* Remove unused/untested Makefile targets lib-pkg [#5494 @kit-ty-kate]
* Upgrade vendored packages (cmdliner 1.3.0, ocaml 4.14.2)
  [#5970 #5976 @kit-ty-kate]
* Upgrade the opam-root-version to 2.2~beta [#5904 @kit-ty-kate]
* Improve and extend the tests
  [#5919 #5919 #5904 #5925 #5935 #5926 #5935 #5927 @rjbou @dra27]
* Improve the benchmarks [#5909 @kit-ty-kate]
* Improve the test infrastructure [#5935 #5938 #5998 @dra27]
* API changes:
  * `OpamClient.init` and `OpamClient.reinit`: now can have additional cygwin
    packages to install [#5930 @moyodiallo]
  * `OpamClientConfig.opam_init`: add `original_root_dir` argument that
     contains the original root directory before redirection [#5457 @rjbou]
  * `OpamClientConfig.opam_init`: add `root_from` argument that contains the
     origin of used root[#5457 @dra27]
  * `OpamInitDefaults.required_packages_for_cygwin`: no longer includes git; as
    the need to add that is computed in `OpamClient` [#6000 @dra27]
  * `OpamSolution`: expose `print_depext_msg` [#5994 @dra27]
  * `OpamSolution`: extract `install_sys_packages` from
    `OpamSolution.install_depexts` [#5994 @dra27]
  * `OpamDownload.download_command`: separate output from stdout and stderr
    [#5984 @kit-ty-kate]
  * `OpamEnv.cygwin_non_shadowed_programs`: exposes the list of executables
    (not including git) which should always come from Cygwin [#6000 @dra27]
  * `OpamStateConfig.r`, `OpamStateConfig.init`: add `original_root_dir` field
    to config record and argument that contains the original root directory
    before redirection [#5457 @rjbou]
  * `OpamStateConfig.r`, `OpamStateConfig.init`: add `root_from` field to
    config record and argument that contains the origin of used root
    [#5457 @dra27]
  * `OpamSysInteract.Cygwin.check_install` renamed to `analyse_install` which
    now also returns whether the installation found was MSYS2 or Cygwin
    [#6000 @dra27]
  * `OpamSysInteract.Cygwin.install`: de-label `packages` argument
    [#6000 @dra27]
  * `OpamFilter.fold_down_left`: correct handling of `FDefined` and `FUndef`
    [#5983 @dra27]
  * `OpamFilter.map_up`: correct handling of `FDefined` [#5983 @dra27]
  * `OpamPath`: add `redirected` the file name of redirected opam root
    [#5457 @rjbou]
  * `OpamPath`: remove `OpamPath.Switch.last_env` function in favor to
    `OpamPath.last_env` as the files are no more stored in switch directory
    [#5962 @moyodiallo - fix #5823]
  * `OpamCompat`: add `Seq.find_map` from OCaml 4.14 [#6000 @dra27]
  * `OpamConsole.menu` now supports up to 35 menu items [#5992 @dra27]
  * `OpamConsole`: Add `formatted_errmsg` [#5999 @kit-ty-kate]
  * `OpamConsole.Symbols`: add `collision` symbol [#5457 @dra27]
  * `OpamProcess.run_background`: name the stderr output file have the .err
    extension when cmd_stdout is given [#5984 @kit-ty-kate]
  * `OpamStd.String`: add `split_quoted` that preserves quoted separator
    [#5935 @dra27]
  * `OpamStd.Sys.resolve_command`: extracted the logic from
    `OpamSystem.resolve_command`, without the default environment handling from
    OpamProcess. [#5991 @dra27]
  * `OpamStd.Sys.resolve_in_path`: split the logic of
    `OpamStd.Sys.resolve_command` to allow searching for an arbitrary file in the
    search path [#5991 @dra27]
  * `OpamStd.Sys.{get_windows_executable_variant,get_cygwin_variant,
    is_cygwin_variant}`: renamed `~cygbin` to `?search_in_path` with a change in
    semantics so that it acts as though the directory was simply the first entry
    in PATH [#6000 @dra27]
  * `OpamStubs.enumRegistry`: on Windows, retrieves all the values of a given
    type from a registry key, with their names [#6000 @dra27]
  * `OpamStubs.getVersionInfo`: on Windows, retrieves the version information
    block of an executable/library [#5963 @dra27]
  * `OpamStubs.get_initial_environment`: on Windows, returns the pristine
    environment for new shells [#5963 @dra27]
  * `OpamStubs.readRegistry`: on Windows, complements `OpamStubs.writeRegistry`
    [#5963 @dra27]
  * `OpamSystem.copy_dir` and `OpamSystem.mv` may display a warning on Windows
    if an invalid symlink (e.g. an LXSS Junction) is found [#5953 @dra27]
  * `OpamSystem`: add `mk_unique_dir` that returns an unique directory name
    as `mk_temp_dir` but not in temporary directory [#5457 @dra27]

2.2.0~beta2:
* Changes necessary to be able to open the PR adding support for Windows in
  opam-repository:
  * Add a init OCaml `sys-ocaml-system` eval variable [#5829 @dra27]
  * Add warning 69: Warn for new syntax when package name in variable in string
    interpolation contains several '+' [#5840 @rjbou]
  * Hijack the `%{?val_if_true:val_if_false}%` syntax to support extending the
    variables of packages with + in their name [#5840 @kit-ty-kate]
  * Handle init OCaml `sys-ocaml-*` eval variables during format upgrade from
    2.0 -> 2.1 -> 2.2 [#5829 @dra27]
  * Add `winsymlinks:native` to the Cygwin environment variable when installing
    a package on Windows [#5793 @kit-ty-kate - fix #5782]
  * Internal Cygwin installation's bin directory is placed as far down PATH as
    is necessary not to shadow `bash`, `tar`, `sort` or `git` [#5832 @dra27]
* Changes necessary for a smooth application of the plan to change
  opam-repository devided in
  https://github.com/ocaml/opam-repository/issues/23789
  * Warn if `GNU patch` is not detected when a patch is applied
    [#5893 @kit-ty-kate]
  * Use `gpatch` by default instead of `patch` on NetBSD and DragonFlyBSD
    [#5893 @kit-ty-kate]
  * Use `gpatch` if it exists and is detected as GNU patch when `patch` is not
    `GNU patch` [#5893 @kit-ty-kate]
* Improve the opam init experience on Windows:
  * Recommend enabling Developer Mode on Windows [#5831 @dra27]
  * Fix MSYS2 support [#5843 @rjbou - fix #5683]
    * Add `sys-pkg-manager-cmd` as an accepted field in opamrc files
      [#5847 @rjbou - fix #5844]
  * Fix `git-location` handling in init config file [#5848 @rjbou - fix #5845]
  * Make the computation of the init default `sys-ocaml-*` eval variables on
    Windows faster, no more depending on Cygwin [#5829 @dra27 @rjbou]
  * Mark the internal cygwin installation as recommended [#5903 @kit-ty-kate]
  * Quote all the paths to `OPAMROOT` when creating the init scripts on Unix in
    case OPAMROOT contains spaces, backslashes or special characters
    [#5841 @kit-ty-kate - fix #5804]
* Improve the internal Cygwin installation during init on Windows:
  * Disable ACL in Cygwin internal install to avoid permission mismatch errors
    [#5796 @kit-ty-kate - fix #5781]
  * Add rsync package to internal Cygwin packages list (enables local pinning
    and is used by the VCS backends [#5808 @dra27]
* Various improvements to the shell integration:
  * Test if file exists before sourcing in fish + powershell
    [#5864 @ElectreAAS]
  * Properly test if "we're in interactive mode" instead of "in a tty" in fish
    script [#5866 @ElectreAAS]
  * Unixify Windows paths in init shells scripts (sh, bash, zsh, fish & tsh)
    [#5797 @rjbou]
* Various improvements to opam init:
  * Simplify computation of OCaml init default `sys-ocaml-*` eval variables on
    Unix [#5829 @dra27]
  * Check for gpatch instead of patch on NetBSD and DragonFlyBSD
    [#5893 @kit-ty-kate]
* Various improvements on Windows:
  * Ensure that the system critical error dialog is disabled when opam starts
    [#5828 @dra27]
  * Fix loading git location at init [#5843 @rjbou]
  * Remove use of deprecated function `SHGetFolderPath` and use
    `SHGetKnownFolderPath` instead [#5862 @kit-ty-kate]
  * Improve performance by only calling `OpamStubs.getPathToSystem` once
    [#5862 @dra27]
* Various improvements to the environment handling:
  * Fix shell detection on Windows when opam is called via Cygwin's
    `/usr/bin/env `even though cmd/powershell is used [#5797 @kit-ty-kate]
  * Fix incorrect deduplication of environment variables on update. Effect was
    that `FOO += ""` would occlude the value of `FOO` in the environment
    [#5837 @dra27]
  * Fix regression from #5356 on the detection of out-of-date environment
    variables. As part of a refactoring, a filter predicate got inverted
    [#5837 @dra27]
* Disable Software Heritage fallbacks by default [#5899 @kit-ty-kate]
* Make sure `opam source --dev` with git sources, clones the whole repository
  instead of using `--depth=1` [#5888 @moyodiallo - fix #5061]
* Add support for Wolfi OS, treat it like Apline family as it uses apk too
  [#5878 @xnox]
* Add support for doas as an alternative to sudo to the installer
  [#5820 @kit-ty-kate - fix #5792]
* Do not check for cppo in the configure script (not used directly anymore
  since #5498) [#5794 @kit-ty-kate]
* Upgrade vendored packages (cmdliner 1.2.0, dune 3.14.2, re 1.11.0, ocamlgraph
  2.1.0, opam-file-format 2.1.6) [#5797 #5869 #5880 #5869 @kit-ty-kate @dra27]
  * Allow to compile opam when the environment contains unicode characters on
    Windows [#5880 @kit-ty-kate - fix #5861]
* Sandbox: Mark the user temporary directory (as returned by `getconf
  DARWIN_USER_TEMP_DIR`) as writable when TMPDIR is not defined on macOS
  [#5780 @ElectreAAS]
* Improve the documentation [#5812 #5818 #5849 #5850 #5885 #5905 #5840 @sorawee
  @AldanTanneo @Khady @kit-ty-kate]
* Improve and extend the tests [#5864 #5829 #5840 #5888 @moyodiallo
  @kit-ty-kate @rjbou]
* Improve the benchmarks [#5900 @kit-ty-kate]
* Improve the test infrastructure [#5851 #5869 #5788 @dra27 @rjbou]
* API changes:
  * `OpamClient.windows_checks`: On existing cygwin install, permit to detect
    MSYS2 and store `os-distribution=msys2` in `global-variables` config file
    field [#5843 @rjbou]
  * `OpamClient.windows_checks`: When updating config file for MSYS2, resolve
    `pacman` path and store it in `sys-pkg-manager-cmd` for MSYS2 [#5843 @rjbou]
  * `OpamArg.apply_global_options`: load MSYS2 Cygwin binary path too
    [#5843 @rjbou]
  * `OpamRepositoryBackend.S.pull_url`, `OpamVCS.fetch`,
    `OpamRepository.pull_tree`: add `full_fetch` optional argument to pull full
    history if url is a `VCS` [#5888 @moyodiallo - fix #5061]
  * `OpamEnv.env_expansion`: Fix detection of out-of-date environment
    variables, a filter predicate was inverted [#5837 @dra27]
  * `OpamSysInteract.Cygwin.check_install`: add `variant` argument to permit
    checking that it is an Cygwin-like install if it is set to true, keep
    checking that it is a strictly Cygwin install if false [#5843 @rjbou]
  * `OpamSysInteract.Cygwin.check_install`: look for `cygcheck.exe` in
    `usr/bin` also as MSYS2 doesn't have "bin" [#5843 @rjbou]
  * `OpamGlobalState.load_config`: load MSYS2 Cygwin binary path too at config
    file loading [#5843 @rjbou]
  * `OpamEnv`: add `sys_ocaml_eval_variables` value, moved `OpamInitDefaults`
    as it is also needed in `OpamFormatUpgrade` too [#5829 @rjbou @kit-ty-kate]
  * `OpamEnv` supports an internal `Cygwin` environment operation which pushes
    the given directory as far down the list as can be done without shadowing.
    This mechanism replaces the opposite which was done in OpamProcess
    [#5832 @dra27]
  * `OpamFile.InitConfig`: add `sys-pkg-manager-cmd` field [#5847 @rjbou]
  * `OpamTypesBase`: add `filter_ident_of_string_interp` that is used for
    parsing variables in string interpolation like `filter_ident_of_string` but
    permits the parsing of '%{?pkg+:var:}%' syntax [#5840 @rjbou]
  * `OpamTypesBase.filter_ident_of_string_interp`: add `accept` optional
    argument to be able to raise an error when several pluses are in the package
    name without using the new syntax, like `%{pkg+++:var}%`
  * `OpamFilter`: add `extract_variables_from_string` to retrieve string of
    variables, and exposes it [#5840 @rjbou]
  * `OpamTypes.env_update` now has an additional type parameter indicating
    whether the update is internal or writeable [#5832 @dra27]
  * `OpamStd.Sys`: add `is_cygwin_variant_cygcheck` that returns true if in
    path `cygcheck` is from a Cygwin or MSYS2 installation [#5843 @rjbou]
  * `OpamStd.Env.cyg_env`: takes the environment to cygify, usually
  `OpamStd.Env.raw_env` [#5829 @dra27]
  * `OpamSystem.patch` now displays a warning when GNU patch is not detected
    and looks for both patch and gpatch as a backup option depending on the OS
    [#5893 @kit-ty-kate]
  * `OpamProcess.cygwin_create_process_env` no longer adjusts PATH
    [#5832 @dra27]

2.2.0~beta1:
* Check and advertise to use Git for Windows [#5718 @rjbou - fix #5617]
  * (+) Add the `--git-location` and `--no-git-location` cli arguments
  * (+) Add a new `git-location` modifiable opam option on Windows
* When compiling opam on Windows with MinGW, the resulting opam binary now
  contains libstdc++ instead of requiring the DLL to be distributed alongside
  it or present in the environment [#5680 @kit-ty-kate - fixes #5647]
  * Add `./configure --enable-static` to compile the opam binary statically
    on Linux
* Fix `opam env` containing carriage return on Cygwin
  [#5715 @dra27 @rjbou @kit-ty-kate - fix #5684]
  * Remove stray comments from pwsh and cmd env
* Fix debug logs showing up regardless of verbosity on
  macOS 12.7.1 / 13.6.3 / 14.2 and FreeBSD [#5769 @kit-ty-kate]
  * Upgrade to, and require mccs >= 1.1+17
* Fix `opam tree --dev` [#5687 @rjbou - fix #5675]
* Fix `opam tree --no-switch`. Instead of emptying the current switch from its
  installed packages, it load a fresh virtual switch [#5687 @rjbou - fix #5675]
* Display a more precise message when Ctrl-C'ing during an opam switch creation
  ("Switch left partially installed") [#5713 @rjbou - fix #5710]
* Improve and fix the release scripts (already used for 2.2.0~alpha3)
  * Workaround incorrect `NGROUPS_MAX` in `<limits.h>` in musl for release
    builds [#5383 @dra27]
  * Fix check for adding `-lsha_stubs` only on `master` on OpenBSD
    [#5733 @punchagan]
* Improve the documentation [#5775 lukstafi]
* Improve and extend the tests [#5687 #5742 @rjbou]
* Improve the test infrastructure [#5723 @dra27]
* API changes:
  * `OpamCoreConfig`: add `git_location` field [#5718 @rjbou ]
  * `OpamStd.Env.cyg_env`: add git location argument and labels
    `cygbin` and `git_location` [#5718 @rjbou]
  * `OpamSystem.apply_cygpath`: runs `cygpath` over the argument
    [#5723 @dra27 - function itself added in #3348]
  * `OpamFile.Config`: add git-location field and its functions
    [#5718 @rjbou]
  * `OpamClient`: on `init` and `reinit` add git lookup in windows
    checks [#5718 @rjbou]
  * `OpamClient.init`: add option `git-location` argument for git 
    binary location configuration  [#5718 @rjbou]
  * `OpamTreeCommand.run`: remove optional argument `no_switch`
    [@rjbou #5687]

2.2.0~alpha3:
* Add `x-env-path-rewrite` extensions field to specify the rewriting rules for
  environment variables defined in `setenv` and `build-env`, useful for
  platforms like Windows [#5636 @rjbou - fix #5602 #4690 #2927]
  * The `environment` file now stores environment variable rewriting rules
    [#5636 @rjbou]
  * Reinstall a package if its `x-env-path-rewrite` is updated [#5636 @rjbou]
* (*) Sandbox: Make /tmp writable again to restore POSIX compliancy
  [#5634 #5662 @kit-ty-kate - fixes #5462]
* (+) opam tree: Allow packages with a specific version, directories or local
  opam files, as input [#5613 @kit-ty-kate]
* (+) opam tree: Add handling of `--recurse` and `--subpath` for directory
  arguments [#5613 @kit-ty-kate]
* (+) opam admin: Add `add-extrafiles` command to add, check, and update
  `extra-files:` field according files present in `files/` directory
  [#5647 @rjbou]
* (+) Allow to mark a set of warnings as errors using a new syntax -W @1..9
  [#5652 @kit-ty-kate @rjbou - fixes #5651]
* Create ppc64le and s390x binaries during releases [#5420 @kit-ty-kate]
* Fix incorrect error message when alternate C compiler is missing on Windows
  [#5667 @dra27 - partial fix #5661]
* Fix `x-locked` error message [#5636 @rjbou]
* opam lint: Improve the debug log when checking extra-files [#5640 @rjbou]
* [BUG] Fix sporadic crash and segfault in shell detection (seen in native
  containers) [#5714 @dra27]
* [BUG] Fix extra-files handling when linting packages from repositories
  [#5639 @rjbou]
* [BUG] On install driven by `.install` file, track intermediate directories
  too, in order to have them suppressed at package removal
  [#5691 @rjbou - fix #5688]
* [BUG] With `--assume-built`, resolve variables in depends filter according
  switch & global environment, not only depends predefined variables
  [#5700 @rjbou - fix #5698]
* [BUG] Handle undefined variables defaults to false in dependencies formula
  resolution for assume built [#5701 rjbou]
* [BUG] Fix `OPAMCURL` and `OPAMFETCH` handling [#5607 @rjbou - fix #5597]
* [BUG] Fix the `OPAMVERBOSE` setting, levels 0 and 1 were inverted: "no" gave
  level 1, and "yes" gave level 0 [#5686 @smorimoto]
* [BUG] Fix "make cold" on Windows when gcc is available
  [#5635 @kit-ty-kate - fixes #5600]
* Improve the documentation [#5636 #5706 #5708 @MisterDA @kit-ty-kate @rjbou]
* Improve and extend the tests [#5560 #5600 #5607 #5636 #5639 #5647 #5672 #5686
  #5691 #5700 #5701 @kit-ty-kate @rjbou]
* Improve the test infrastructure [#5560 #5606 #5607 #5607 #5654 #5657 @rjbou]
* API changes:
  * `OpamSystem.mk_temp_dir`: resolve real path with `OpamSystem.real_path`
    before returning it [#5654 @rjbou]
  * `OpamSystem.resolve_command`: in command resolution path, check that the
    file is not a directory and that it is a regular file
    [#5606 @rjbou - fix #5585 #5597 #5650 #5626]
  * `OpamStd.Config.env_level`: fix level parsing, it was inverted (eg, "no"
    gives level 1, and "yes" level 0) [#5686 @smorimoto]
  * `OpamStd.Sys.chop_exe_suffix`: removes `.exe` from the end of a path, if
     present [#5714 @dra27]
  * `OpamSystem.get_cygpath_path_transform`: add labeled argument to specify
    if path is a pathlist [#5636 @rjbou]
  * `OpamSystem.apply_cygpath_path_transform`: fix cygpath call, use resolved
    name [#5716 @rjbou]
  * `OpamTreeCommand.run`: now takes an `atom` instead of `name`
    [#5613 @kit-ty-kate]
  * `OpamFilter`: add `expand_interpolations_in_file_full` which allows setting
    the output file along with the input file [#5629 @rgrinberg]
  * `OpamFilter`: expose `string_interp_regex` which allows clients to identify
    variable interpolations in strings [#5633 @gridbugs]
  * `OpamTypes.env_update`: change from tuple to a record [#5636 @rjbou]
  * `OpamTypesBase`: add `env_update`, `env_update_resolved`, and
    `env_update_unresolved` builders [#5636 @rjbou]
  * `OpamTypes.env_update`: add a `rewrite` field, that contains environment
    variable rewriting rules (formula to resolved, or already resolved, or no
    rewriting) [#5636 @rjbou]
  * `OpamPp.fallback`: add name concatenation and printing fallback too
    [#5636 @rjbou]
  * `OpamFormat`: add `formula_items` to permit definition of formulae pp not
    only of the type `package-formula` [#5636 @rjbou]
  * `OpamTypesBase`: add to_string function for `path_format` & `separator`
    [#5636 @rjbou]
  * `OpamFormat.V`: add `path_format` & `separator` value parser printer
    [#5636 @rjbou]
  * `OpamFile.OPAM`: add handling of `x-env-path-rewrite` extensions field,
    that specifies rewrite rules [#5636 @rjbou]
  * `OpamFile.Environment`: add parsing-printing of rewriting rules, keeping
    backward compatibility [#5636 @rjbou]
  * `OpamFile.OPAM`: `effective_part` keeps `x-env-path-rewrite`, affects also
    `effectively_equal` [#5636 @rjbou]
  * `OpamTypesBase`: add `env_update_resolved` and `env_update_unresolved`
    builders [#5636 @rjbou]
  * `OpamPp.fallback`: add name concatenation and printing fallback too
    [#5636 @rjbou]
  * `OpamFormat`: add `formula_items` to permit definition of formulae pp not
    only of the type `package-formula` [#5636 @rjbou]
  * `OpamTypesBase`: add to_string function for `path_format` & `separator`
    [#5636 @rjbou]
  * `OpamFormat.V`: add `path_format` & `separator` value parser printer
    [#5636 @rjbou]
  * `OpamFile.OPAM`: add handling of `x-env-path-rewrite` extensions field,
    that specifies rewrite rules [#5636 @rjbou]
  * `OpamFile.Environment`: add parsing-printing of rewriting rules, keeping
    backward compatibility [#5636 @rjbou]
  * `OpamFile.OPAM`: `effective_part` keeps `x-env-path-rewrite`, affects also
    `effectively_equal` [#5636 @rjbou]

2.2.0~alpha2:
* Permit internal Cygwin install on Windows [#5545 @rjbou @dra27]
* Add `--no-cygwin-setup`, `--cygwin-internal-install`,
  `--cygwin-local-install` and `--cygwin-location <path>` experimental flags
  available only on Windows to permit non-interactive Cygwin configuration
  [#5545 @rjbou]
* opam var/option: Error with more accurate message in case of package/self
  variable wrongly given as argument [#4903 @rjbou - fix #4489]
* [BUG] opam var/option: Handle package variable syntax in parse update
  regexp [#4903 @rjbou - fix #4489]
* Lint: E29: The conflicts field's filter does not support package variables
  [#5535 @kit-ty-kate]
* opam admin: On linting, clean output when stdout is not tty [#5594 @rjbou]
* Run autoupdate to silence autogen warnings [#5555 @MisterDA]
* Update bootstrap to use FlexDLL 0.43 from ocaml/flexdll [#5579 @MisterDA]
* configure: Ensure a complementary (32bit on 64bit platforms and 64bit on
  32bit platforms) C compiler is installed on Windows [#5522 @kit-ty-kate]
* Bump versions, fix authors [#5603 #5609 #5611 @rjbou]
* Improve and extended tests: [#5385 #5535 @rjbou]
* Improve test engine: [#5481 @dra27]
* Improve Github actions: [#5555 #5588 #5598 @rjbou]

2.2.0~alpha:
* Depexts support Cygwin on Windows [#5542 @rjbou] [#5544 @rjbou]
  [#5541 @dra27]
* Support MSYS2 on Windows for depexts [#5348 @jonahbeckford #5433 @rjbou]
* Generate init and variables for Windows [#5541 @dra27]
* When defined, add Cygwin binary path to build environment [#5543 @rjbou]
* On Windows, ask for pre-existent Cygwin installation, check it, and configure
  opam with it [#5544 @dra27 @rjbou]
* Reactivate subpath and recursive pinning `--recursive` and `--subpath`
  [#4876 @rjbou] [#5219 @rjbou]
* (+) Add `tree` subcommand to display a dependency tree of currently installed
  packages [#5171 @cannorin - fix #3775] [#5303 @cannorin - fix #5298]
* (+) Add `why` subcommand to examine how the versions of currently installed
  packages get constrained (alias to `tree --rev-deps`)
  [#5171 @cannorin - fix #3775]
* (+) Add `--formula` option to specify a formula to install [#4975 @AltGr]
* (+) Add `--dev-setup` option to install recommended development tools from
  opam file (as `with-test`/`with-doc`), and its environment variable
  `OPAMWITHDEVSETUP`, and for post-messages
  [#5016 #5160 #5214 @rjbou - fix #4959]
* Opamfile: Add `with-dev-setup` variable for recommended tools
  [#5016 #5214 @rjbou]
* Factorise source-archive fetching. If several packages relies on the same
  archive, it is downloaded once then copied to several source directories
  [#4893 @rjbou - fix #3741]
* Add Software heritage fallback when downloading archive source, triggered
  when all urls and cache fails, with confirmation [#4859 @rjbou @zapashcanon]
* Opamfile: Add swhid url handling in url field [#4859 @rjbou @zapashcanon]
* (+) New option `opam pin --current` to fix a package in its current state
  (avoiding pending reinstallations or removals from the repository)
  [#4973 @AltGr - fix #4970]
* (+) Add `opam pin remove --all` to remove all the pinned packages from a
  switch [#5308 @kit-ty-kate]
* Allow `opam pin remove` to take a package (`<pkg>.<version>`) as argument
  [#5325 @kit-ty-kate]
* (+) Add `opam exec --no-switch` [#4957 @kit-ty-kate - fix #4951]
* (+) Add `--no-switch` option [#4850 @rjbou - fix #4858]
* (+) Add `--untracked` option to remove interactively untracked files
  [#4915 @rjbou - fix #4831]
* (+) Add support for `opam switch -` that goes to previous non-local switch
  [#4910 @kit-ty-kate - fix #4688]
* (+) Add `opam admin add-constraint <cst> --packages` to select a subset of
  packages to apply constraints [#5386 @rjbou - fix #3077]
* (+) Add `OPAMREPOSITORYTARRING` environment variable to enable repository
  tarring optimisation, it is disabled by default because it is an optimisation
  only on some os/configurations [#5015 @rjbou]
* Run the sandbox check in the temporary directory [#4787 @dra27 - fix #4783]
* Use `.opam` from `%HOME%` or `%USERPROFILE%` on Windows, only if found;
  otherwise use `%LOCALAPPDATA%\opam` as root. [#5212 @dra27]
* Display actual location of OPAMROOT in `opam init` if `--root` or `OPAMROOT`
  have been set [#5212 @dra27 - fix #4992]
* Surround and add a comment describing the role of the lines added to the
  ~/.profile or equivalent [#5456 @kit-ty-kate]
* Use menu for init setup [#5057 @AltGr; #5217 @dra27]
* (*) init menu: change default from no to yes for shell update
  [#5456 #5540 @rjbou @kit-ty-kate]
* [BUG] Fix `opam init` and `opam init --reinit` when the `jobs` variable has
  been set in the opamrc or the current config. [#5056 @rjbou]
* Handle empty environment variable updates - missed cherry-pick from 2.0
  [#4840 @dra27]
* When a field is defined in switch and global scope, try to determine the
  scope also by checking switch selection [#5027 @rjbou]
* Resolve and use global config and environment variable before polling system
  informations (os, os-family, etc.) [#4892 @rjbou - fix #4883]
* Catch an package not found error and print skipping message
  [#5280 @rjbou - fix #5279]
* Option: Make `archive-mirrors` modifiable (extendable) via opam config
  [#5321 @hannesm @rjbou - fix #5316]
* Open the release files when determining the distribution
  [#5568 @Leonidas-from-XIV]
* [BUG] Fix `OPAMCURL` and `OPAMFETCH` value setting [#5111 @rjbou - fix #5108]
* [BUG] Option: Don't error when displaying if switch is not set
  [#5027 @rjbou - fix #5025]
* [BUG] Try to set a variable with option `--switch <sw>` fails instead of
  writing a wrong `switch-config` file [#5027 @rjbou]
* [BUG] Fix typo in error message for opam var [#4786 @kit-ty-kate - fix #4785]
* Config report: Add invariant and compiler packages fields
  [#5480 @rjbou - fix #5478]
* [BUG] Config report: Don't fail if no switch is set [#5198 @rjbou]
* Add CLI 2.2 handling [#4853 @rjbou]
* `--no-depexts` is the default in CLI 2.0 mode [#4908 @dra27]
* CLI: Error report display: print action name [#5045 @AltGr]
* CLI: Add `experimental` flags handling [#5099 @rjbou]
* Put back support for switch creation with packages argument and `--packages`
  option with CLI 2.0, and a specific error message for CLI 2.1
  [#4853 @rjbou - fix #4843]
* Fix default CLI handling for simple flags [#5099 @rjbou]
* Check whether the repository might need updating more often
  [#4935 @kit-ty-kate]
* (*) It is no longer possible to process actions on packages that depend on a
  package that was removed upstream [#4969 @AltGr]
* (*) PEF output: change `base` field into `invariant-pkg` [#5208 @rjbou]
* [BUG] Fix all empty conflict explanations [#4982 #5263 @kit-ty-kate]
  partially}_
* [BUG] Fix passing `archive-mirrors` field from init config file to config
  [#5315 @hannesm]
* [BUG] Fix json double printing [#5143 @rjbou]
* Reimplement deps-only [#4975 @AltGr] [#5136 @AltGr]
  [#5236 @AltGr - fix #5177] [#5236 @AltGr - fix #5185]
* Log a summary of recorded `.changes` as a `ACTION` trace log to help debug
  #4419 [#5144 @na4zagin3]
* Use the default criteria during reinstall/upgrade when requesting at least
  one non-installed package [#5228 @kit-ty-kate]
* [BUG] Prevent `.changes` files from being updated during dry-run
  [#5144 @na4zagin3 - fix #5132]
* Make the status of pinned packages more explicit during installation
  [#4987 @kit-ty-kate - fix #4925]
* Show the reason for installing packages when using opam reinstall
  [#5229 @kit-ty-kate]
* Refresh the actions list output, now sorted by action/package rather than
  dependency [#5045 @kit-ty-kate @AltGr - fix #5041]
* Put back the actions summary as part of confirmation question [#5045 @AltGr]
* Add subpath on actions listing urls [#4876 @rjbou]
* [BUG] Fix display of pinned packages in action list [#5079 @rjbou]
* Fix message when running `opam remove` on an unavailable package
  [#4995 @AltGr - fix #4890]
* Fix removal of root packages with `-a` and an optional dependency explicitly
  specified [#4995 @AltGr - fix #4727]
* On switch loading, check for executable external files if they are in `PATH`,
  and warn if not the case [#4932 @rjbou - fix #4923]
* When inferring a 2.1+ switch invariant from 2.0 base packages, don't filter
  out pinned packages as that causes very wide invariants for pinned compiler
  packages [#5176 @dra27 - fix #4501]
* When setting invariant, really install invariant formula if not installed in
  switch [#5188 @rjbou]
* When setting invariant, update switch state to compute invariant packages
  [#5208 @rjbou]
* On switch import, check that installed pinned packages changed, reinstall if
  so [#5181 @rjbou - fix #5173]
* Update compiler / base packages handling: always updated, the field contains
  installed packages resolving invariant formula [#5208 @rjbou]
  [#5503 @kit-ty-kate - fix #5502]
* Fill empty switch synopsis with invariant formula instead of compiler package
  name [#5208 @rjbou]
* [BUG] Ensure setenv can use package variables defined during the build
  [#4841 @dra27]
* [BUG] Fix `set-invariant`: default repos were loaded instead of switch repos
  [#4866 @rjbou]
* [BUG] Enforce extra-source to have a checksum when using "opam switch export
  --freeze" [#5418 @kit-ty-kate]
* Switch the default pin version when undefined from `~dev` to `dev`
  [#4949 @kit-ty-kate]
* pin scan: show subpaths [#4876 @rjbou]
* [BUG] Fix using `--working-dir` with non pinned packages: it was not
  downloading sources as they were remove from package that need sources
  [#5082 @rjbou - fix #5060]
* [BUG] Fix windows path for subpath, by introducing their own type in
  `OpamFilename` [#4876 @rjbou]
* [BUG] Fix recpin of locked pins when there is no change in lock file
  [#5079 @rjbou - fix #4313]
* [BUG] Fix `opam install ./file.opam` lock pinning [#5148 @rjbou - fix #4313]
* [BUG] Fix origin opam file retrieval when opam originate from locked file
  [#5079 @rjbou - fix #4936]
* [BUG] When reinstalling a package that has a dirty source, if uncommitted
  changes are the same than the ones stored in opam's cache, opam consider that
  it is up to date and nothing is updated [#4879 @rjbou]
* [BUG] Handle external dependencies when updating switch state pin status (all
  pins), instead as a post pin action (only when called with `opam pin`
  [#5047 @rjbou - fix #5046]
* Some optimisations to 'opam list --installable' queries combined with other
  filters [#4882 @AltGr - fix #4311]
* Improve performance of some opam list combination (e.g. --available
  --installable) [#4999 @kit-ty-kate]
* Improve performance of opam list --conflicts-with when combined with other
  filters [#4999 @kit-ty-kate]
* Improve performance for recursive `--required-by` and `depends-on`
  [#5337 @rjbou]
* Colorise as unavailable (magenta) packages that are specified in the
  invariant formula and that do not verify it (previous was non installed
  compiler package) [#5208 @rjbou]
* (*) Change `--base` into `--invariant`, column name and the content is
  invariant formula installed dependencies [#5208 @rjbou]
* [BUG] Fix coinstallability filter corner case [#5024 @AltGr]
* Show: Add `depexts` to default printer [#4898 @rjbou]
* Show: Add printer for `url.swhid:` [#4859 @rjbou]
* Make `opam show --list-files <pkg>` fail with not found when `<pkg>` is not
  installed [#4956 @kit-ty-kate - fix #4930]
* Improve performance of opam show by 300% when the package to show is given
  explicitly or unique [#4998 @kit-ty-kate - fix #4997 and partially #4172]
* Download source even if no switch is set
  [#4850 @rjbou @zapashcanon - fix #4809]
* Source: [BUG] Fix directory display in dev mode [#5102 @rjbou]
* [BUG] if a package is pinned from a locked file, it is automatically
  updated/upgraded accordingly a lock file (same extension) [#5080 @rjbou]
* More clear message for pinned package update that have local changes, with no
  working dir given, or no arguments specified [#5300 @rjbou - fix #5294]
* Lint: Warning 68: add warning for missing license field
  [#4766 @kit-ty-kate - partial fix #4598]
* Lint: Warning 47: remove the mention of the opam 1.2 descr file in the
  warning message [#5069 @rjbou - fix #4989]
* Lint: Warning 56: detection removed, since `OPAM_LAST_ENV` allows reliable
  reverting [#5417 @dra27]
* Lint: Error 57: (capital on synopsis) not trigger Warning 47 (empty descr)
  [#5070 @rjbou]
* Lint: Error 57: Enforce synopsis to always be there, restoring behaviour from
  opam 2.1 [#5442 @kit-ty-kate]
* Lint: Update repository package filename display [#5068 @rjbou]
* Lint: Warning 62: use the spdx_licenses library to check for valid licenses.
  This allows to use compound expressions such as "MIT AND (GPL-2.0-only OR
  LGPL-2.0-only)", as well as user defined licenses e.g.
  "LicenseRef-my-custom-license" [#4768 @kit-ty-kate - fixes #4598]
  [#5571 @3Rafal - fix #5570]
* [BUG] Lint: Fix linting packages from repository with tarred repositories,
  the file in temporary repository was no more available when lint is done
  [#5068 @rjbou]
* Lint: Error 67: check checksums only for VCS urls [#4960 @rjbou]
* [SECURITY] Fix opam installing packages without checking their checksum when
  the local cache is corrupted in some cases [#5538 @kit-ty-kate]
* When several checksums are specified, instead of adding in the cache only the
  archive by first checksum, name by best one and link others to this archive
  [#4696 rjbou]
* Set the priority of user-set archive-mirrors higher than the repositories'.
  This allows opam-repository to use the default opam.ocaml.org cache and be
  more resilient to changed/force-pushed or unavailable archives.
  [#4830 @kit-ty-kate - fixes #4411]
* Repository tarring "optimisation" no more needed, removed in favor of a plain
  directory. It still can be used with environment variable
  `OPAMREPOSITORYTARRING`. [#5015 @kit-ty-kate @rjbou @AltGr - fix #4586]
  [#5109 @rjbou]
* Avoid reloading repository contents when the repo has no changes
  [#5043 @Armael]
* Avoid rewriting repository cache is nothing changed [#5146 @rjbou]
* On setting url fetch failure (sync or file error), revert url change and
  rollback to old one [#4967 @rjbou - fix #4780 #4779]
* Update opam repository man doc regarding removal of the last repository in a
  switch [#4435 - fixes #4381]
* Don't display global message when `opam repo`'s `--this-switch` is given
  [#4899 @rjbou - fix #4889]
* Remove url section from lock file, it is ignored on pinning [#5465 @rjbou]
* Fix lock generation of multiple interdependent packages [#4993 @AltGr]
* Depext: Run command as admin only when needed [#5268 @kit-ty-kate]
* Depext: Don't run depext computation when there is no depexts [#5548 @rjbou]
* [BUG] Depext: when checking again, more accurate check of missing packages
  (available and not found) [#5157 @rjbou]
* Depext: Better recognize depexts on Gentoo, NetBSD, OpenBSD [#5065 @mndrix]
* Depext: Set `DEBIAN_FRONTEND=noninteractive` for unsafe-yes confirmation
  level [#4735 @dra27 - partial fix #4731] [2.1.0~rc2 #4739]
* Depext: Homebrew: Add support for casks and full-names [#4801 @kit-ty-kate]
* Depext: Disable the detection of available packages on RHEL-based
  distributions. This fixes an issue on RHEL-based distributions where yum list
  used to detect available and installed packages would wait for user input
  without showing any output and/or fail in some cases
  [#4791 @kit-ty-kate - fixes #4790]
* Depext: Fallback on dnf if yum does not exist on RHEL-based systems
  [#4825 @kit-ty-kate]
* Depext: Archlinux: handle virtual package detection
  [#4831 @rjbou - partial fix #4759]
* Depext: Stop zypper from upgrading packages on updates on OpenSUSE
  [#4978 @kit-ty-kate]
* [BUG] Depext: Fix depext alpine tagged repositories handling [#4763 @rjbou]
  [2.1.0~rc2 #4758]
* Depext: Improve the error message when neither MacPorts or Homebrew could be
  detected on macOS [#5240 @kit-ty-kate]
* Depext: Print depexts together with action list on `--show` [#5236 @AltGr]
* Depext: Don't display system package manager helper if packages are not found
  [#5157 @rjbou]
* Depext: Increase verbose logging of command to 4 [#5151 @rjbou]
* Depext: Refactored depext-related questions, with a flat menu instead of
  nested y/n questions [#5053 @AltGr - fix #5026] [#5155 @rjbou] [#5295 @AltGr]
  [#5499 @AltGr]
* Depext: Introduce dummy-success & dummy-failure os-family to make testing
  depexts behaviour easier [#5268 @kit-ty-kate] [#5453 @rjbou @dra27]
* dash: recognize dash as a POSIX shell for opam env [#4816 @jonahbeckford]
* pwsh,powershell: use $env: for opam env [#4816 @jonahbeckford] [#5541 @dra27]
  [#5541 @dra27]
* command prompt: use `set` for opam env [#4816 @jonahbeckford] [#5541 @dra27]
* [BUG] fish: fix deprecated redirection syntax `^` [#4736 @vzaliva]
* (*) `opam admin cache` now ignores all already present cache files. Option
  `--check-all` restores the previous behaviour of validating all checksums.
* [BUG] Admin: Fix repo-upgrade internal error [#4965 @AltGr]
* [BUG] Admin: Fix `--environment` documentation [#5235 @rjbou - fix #5184]
* [BUG] Admin: Fix opam admin add-constraint failing with Not_found in some
  situations [#5336 @kit-ty-kate - fix #5334]
* Sandbox: Sync the behaviour of the macOS sandbox script with Linux's: /tmp is
  now ready-only [#4719 @kit-ty-kate]
* Sandbox: Always mount every directories under / on Linux [#4795 @kit-ty-kate]
* Sandbox: Get rid of `OPAM_USER_PATH_RO` (never used on macOS and no longer
  needed on Linux) [#4795 @kit-ty-kate]
* Sandbox: Resolve symlink for `ccache` directory [#5267 @rjbou - fix #5194]
* Sandbox: Enforce the macOS sandbox script to use `/bin/bash` instead of
  `/usr/bin/env bash` for a more consistent experience [#5451 @kit-ty-kate]
* Sandbox: Print error message if command doesn't exist
  [#4971 @kit-ty-kate - fix #4112]
* Opamfile: Add `x-locked` extension fields for overlay internal use, it stores
  if the files originate from a locked file, if so its extension [#5080 @rjbou]
* Opamfile: Set `depext-bypass` parsing with depth 1, no needed bracket if
  single package [#5154 @rjbou]
* [BUG] Opamfile: Fix substring errors in `to_string_with_preserved_format
  [#4941 @rjbou - fix #4936]
* [BUG] Opamfile: Variables are now expanded in build-env (as for setenv)
  [#5352 @dra27]
* Solver: Add builtin support for the 'deprecated' flag. Any packages flagged
  with deprecated would be avoided by the solver unless there is no other
  choice (e.g. some user wants to install package a which depends on b which is
  deprecated) If it is installed, show up a note after installation notifying
  the user that the package is deprecated. [#4523 @kit-ty-kate]
* Solver: Make sure that `--best-effort` only installs root package versions
  that where requested [#4796 #5261 @LasseBlaauwbroek]
* Solver: Ask users to report errors when no explanations are given to them
  [#4981 @kit-ty-kate]
* Solver: Fix and improve the Z3 solver backend [#4880 @AltGr]
* Solver: Refactored, fixed, improved and optimised the z3 solver backend
  [#4878 @AltGr]
* Solver: Add an explanation for "no longer available" packages [#4969 @AltGr]
* Solver: Orphan packages are now handled at the solver level instead of a
  pre-processing phase, better ensuring consistency [#4969 @AltGr #5182 @rjbou]
* Solver: Make the 0install solver non-optional [#4909 @kit-ty-kate]
* Solver: Optimised reverse dependencies calculation [#5005 @AltGr]
* Solver: Enable CUDF preprocessing for (co)insallability calculation,
  resulting in a x20 speedup [#5024 @AltGr]
* Solver: Log the time dose3's check_request takes [#5407 @kit-ty-kate]
* [BUG] Solver: On CUDF strong and weak dependencies computation, some weak
  dependencies were wrongly kept, from #4627 [#5338 @rjbou @AltGr]
* [BUG] Solver: Fix "opam list -s --coinstallable-with pkg.1 pkg.2" listing
  pkg.2 as coinstallable with pkg.1 [#5414 @kit-ty-kate]
* Repository state: stop scanning directory once opam file is found
  [#4847 @rgrinberg]
* Fix reverting environment additions to PATH-like variables when several dirs
  added at once [#4861 @dra27]
* Actually allow multiple state caches to co-exist [#4934 @dra27 - fix #4554]
* Don’t rebuild packages when updating dependencies or availability, unless the
  current state needs to be changed [#5118 @kit-ty-kate - fix #4647]
* Rebuild packages when removing or adding the "plugin" flag
  [#5118 @kit-ty-kate]
* Do not rebuild packages when an extra-source's url changes but not its
  checksum [#5258 @kit-ty-kate]
* Correctly handle empty environment variable additions [#5350 @dra27]
* Skip empty environment variable additions [#5350 @dra27]
* State config: Add `sys-pkg-manager-cmd` field to store specific system
  package manager command paths [#5433 @rjbou]
* State config: Regenerate the environment file when a local switch is moved
  [#5476 @dra27 - fix #3411]
* State config: Regenerate the environment file in `opam exec` [#5476 @dra27]
* State config: Regenerate the environment file when a local switch is moved
  [#5417 @dra27 - fix #3411]
* State config: Regenerate the environment file in `opam exec` [#5417 @dra27]
* State config: Store the exact environment in `OPAM_LAST_ENV`
  [#5417 @dra27 - fix #3411]
* VCS: git, hg: Use the full SHA1 revision instead of just the 8 first
  characters [#5342 @reynir]
* VCS: git: differentiate non initialised repo and branch not found errors
  [#5326 @rjbou - fix #5324]
* VCS: Pass `--depth=1` to git-fetch in the Git repo backend [#4442 @dra27]
* VCS: git: disable colored output [#4884 @rjbou]
* VCS: Use 4.08's unnamed functor arguments to silence warning 67
  [#4775 @dra27]
* VCS: Check if a source is up to date with subpath [#4876 @rjbou]
* Format upgrade: Reorganise intermediate roots that need an upgrade handling
  (for 2.1, prone to generalisation) [#4926 @rjbou]
* Format upgrade: Reset the "jobs" config variable when upgrading from opam 2.0
  [#5284 @kit-ty-kate #5305 @rjbou]
* Format upgrade: Fix root format upgrade when only an inner file format is
  upgraded : new mechanism does the usual on-the-fly upgrade and keeps the
  information of needed inner upgrade or no, to perform them when a write lock
  is required [#5305 @rjbou]
* Windows: Support MSYS2: treat MSYS2 and Cygwin as equivalent
  [#4813 @jonahbeckford]
* Windows: Process control: close stdin by default for Windows subprocesses and
  on all platforms for the download command [#4615 @dra27]
* Windows: OpamCudf: provide machine-readable information on conflicts caused
  by cycles [#4039 @gasche]
* Windows: Remove memoization from `best_effort ()` to allow for multiple
  different settings during the same session (useful for library users)
  [#4805 @LasseBlaauwbroek]
* Windows: Permissions: chmod+unlink before copy [#4827 @jonahbeckford @dra27]
* Windows: Support MSYS2: two-phase rsync on MSYS2 to allow MSYS2's behavior of
  copying rather than symlinking [#4817 @jonahbeckford]
* Windows: Environment: translate PATH from Windows to Unix during opam env.
  [#4844 @jonahbeckford]
* Windows: Correct invocation of Cygwin binaries when Cygwin bin directory is
  first in PATH [#5293 @dra27]
* Windows: Always open files with `O_SHARE_DELETE`, which eliminates
  unnecessary "access denied" errors in various situations on Windows.
  [#5435 @dra27]
* Windows: Use OCaml code to copy/move/remove directories instead of unix
  commands [#4823 @kit-ty-kate - fix #1073]
* Windows: Update Windows-on-Windows detection for ARM [#5541 @dra27]
* Windows: Overhaul parent process detection [#5541 @dra27]
* Windows: Tweak UTF-8 support for Windows Terminal [#5541 @dra27]
* Windows: Handle Windows specific environment variables [#5541 @dra27]
* [BUG] Windows: handle converted variables correctly when no_undef_expand is
  true [#4811 @timbertson]
* [BUG] Windows: check Unix.has_symlink before using Unix.symlink
  [#4962 @jonahbeckford]
* [BUG] Windows: Catch `EACCES` in lock function [#4948 @oandrieu - fix #4944]
* [BUG] Windows: Fix case insensitive variable handling [#5356 @dra27]
* Add license and lowerbounds to opam files [#4714 @kit-ty-kate]
* Bump version to 2.2.0~alpha~dev [#4725 @dra27]
* Upgrade root version to 2.2~alpha [#4926 @rjbou]
* Add specific comparison function on several module (that includes
  `OpamStd.ABSTRACT`) [#4918 @rjbou]
* Homogeneise `is_archive` tar & zip: if file exists check magic number,
  otherwise check extension [#4964 @rjbou]
* Add some debug log to OpamCudf.extract_explanations to help debug #4373
  [#4981 @kit-ty-kate]
* Make SHA computation faster by using ocaml-sha [#5042 @kit-ty-kate]
* Overhaul Windows C stubs and update for Unicode [#5190 @dra27]
* Unify constructors for powershell hosts [#5203 @dra27]
* Use `grep -F` instead of `fgrep`, as the latter is deprecated
  [#5309 @MisterDA]
* Ensure the cwd is restored when launching a process fails [#5441 @dra27]
* Move the .ocamlinit script out of the root directory [#5526 @kit-ty-kate]
* Do not show --yes and --no as special global options when using cmdliner >=
  1.1 [#5269 @kit-ty-kate]
* Make the plugin lookup faster when mistyping a subcommand
  [#5297 @kit-ty-kate]
* [BUG] Remove windows double printing on commands and their output
  [#4940 @rjbou]
* [BUG] Fix display of command when parallelised [#5091 @rjbou]
* [BUG] Display correct exception backtrace on uncaught exception on Windows
  [#5216 @dra27]
* [BUG] Fix behaviour on closed stdout/stderr [#4901 @AltGr - fix #4216]
* [BUG] Fix spaces in root and switch dirs [#5203 @jonahbeckford]
* [BUG] Fix linting on opam-crowbar.opam [#5507 @kit-ty-kate]
* [BUG] Fix lazy compilation of regular expression in
  OpamFormula.atom_of_string [#5211 @dra27]
* Bump the minimum requirement to build any of the opam libraries to OCaml >=
  4.08 [#5466 @kit-ty-kate]
* src-ext: Add `jsonm` (and `uutf`) dependency [#5098 @rjbou - fix #5085]
  [#5467 @kit-ty-kate]
* src-ext: Add `sha` dependency [#5042 @kit-ty-kate] [#5424 @kit-ty-kate]
* src-ext: Add `swhid_core` dependency [#4859 @rjbou] [#5497 @kit-ty-kate]
* src-ext: Bump vendored base64 to 3.5.1 to fix compilation on OCaml >= 5.0 in
  vendored mode [#5464 @deech]
* src-ext: Bump src_exts and fix build compat with Dune 2.9.0 [#4752 @dra27]
* src-ext: Upgrade to dose3 >= 6.1 and vendor dose3 7.0.0 [#4760 @kit-ty-kate]
* src-ext: Change minimum required Dune to 2.0 [#4770 @dra27]
* src-ext: Change minimum required OCaml to 4.08.0 for everything except
  opam-core, opam-format and opam-installer [#4770 #4775 @dra27]
* src-ext: Update bootstrap ocaml to 4.12.1 to integrate mingw fix
  [#4927 @rjbou]
* src-ext: Update cold compiler to 4.13 [#5017 @dra27]
* src-ext: Bump opam-file-format to 2.1.4 [#5117 @kit-ty-kate - fix #5116]
* src-ext: Bump CUDF to 0.10 [#5195 @kit-ty-kate]
* src-ext: Upgrade to cmdliner >= 1.1 [#5269 @kit-ty-kate]
* src-ext: Update the bootstrap compiler to 4.14.0 [#5250 @kit-ty-kate]
* src-ext: Upgrade the vendored dune to 3.5.0 to fix make cold in an OCaml 5.0
  env [#5355 @kit-ty-kate]
* src-ext: Upgrade vendored deps to support lib-ext in OCaml 5.0
  [#5355 @kit-ty-kate @dra27]
* src-ext: Upgrade spdx_licenses to 1.2.0 [#5412 @kit-ty-kate]
* src-ext: Upgrade src_ext vendored bootstrap dependencies [#5437 @MisterDA]
* src-ext: Update bootstrap to use FlexDLL 0.42 from ocaml/flexdll
  [#5434 @MisterDA]
* src-ext: Remove unused vendored dependency: result [#5465 @kit-ty-kate]
* src-ext: Replace CPPO dependency with simple conditional compilation helper
  [#5498 @Leonidas-from-XIV]
* build: Fix the cold target in presence of an older OCaml compiler version on
  macOS [#4802 @kit-ty-kate - fix #4801]
* build: Harden the check for a C++ compiler [#4776 @dra27 - fix #3843]
* build: Add `--without-dune` to configure to force compiling vendored Dune
  [#4776 @dra27]
* build: Use `--without-dune` in `make cold` to avoid picking up external Dune
  [#4776 @dra27 - fix #3987]
* build: Add `--with-vendored-deps` to replace `make lib-ext` instruction
  [#4776 @dra27 - fix #4772] [#5511 @kit-ty-kate #5539 @rjbou]
* build: Add a 'test' target [#5129 @kit-ty-kate @mehdid - partial fixes #5058]
* build: Fix vendored build on mingw-w64 with g++ 11.2 [#4835 @dra27]
* build: Switch to vendored build if spdx_licenses is missing [#4842 @dra27]
* build: Check versions of findlib packages in configure [#4842 @dra27]
* build: Fix dose3 download url since gforge is gone [#4870 @avsm]
* build: Update bootstrap to use `-j` for Unix (Windows already does)
  [#4988 @dra27]
* build: Bring the autogen script from ocaml/ocaml to be compatible with
  non-ubuntu-patched autoconf [#5090 @kit-ty-kate #5093 @dra27]
* build: configure: Use gmake instead of make on Unix systems (fixes BSDs)
  [#5090 @kit-ty-kate]
* build: Patch AltGr/ocaml-mccs#36 in the src_ext build to fix Cygwin32
  [#5094 @dra27]
* build: Silence warning 70 [#5104 @dra27]
* build: shell/bootstrap-ocaml.sh: do not fail if curl/wget is missing
  [#5223 #5233 @kit-ty-kate]
* build: Cleared explanation of dependency vendoring in configure
  [#5277 @dra27 - fix #5271]
* build: Switch autoconf required version to 2.71 [#5161 @dra27]
* build: Remove src/client/no-git-version when calling make clean
  [#5290 @kit-ty-kate]
* build: Remove unused variable in opamACL.c [#5403 @purplearmadillo77]
* build: shell/bootstrap-ocaml.sh: do not fail if curl/wget is missing
  [#5223 @kit-ty-kate]
* build: `opam-state` depends on `opam-solver` [#5208 @rjbou]
* build: Specify the `opam` package for all rules that need `opamMain.exe.exe`
  [#5496 @Leonidas-from-XIV]
* build: Remove conditional compilation [#5508 @Leonidas-from-XIV]
* build: Update msvs-detect [#5514 @MisterDA]
* build: Do not silently disable mccs if a C++ compiler is not present
  [#5527 @kit-ty-kate - fix #4452]
* build: Ensure all make targets are run serially [#5532 @kit-ty-kate]
* build: Fix openssl missing message in `shell/bootstrap-ocaml.sh`
  [#5557 @MisterDA]
* build: Fix detection of C++ compiler when it is prefixed [#5556 @MisterDA]
* Improve documentation [#4421 #4782 #4855 #4863 #4896 #5001 #5040 #5095 #5097
  #5159 #5165 #5167 #5168 #5215 #5226 #5289 #5311 #5340 #5343 #5512 #5175
  @AltGr @cnmade @dra27 @emillon @gasche @Armael @hannesm @javiljoen
  @johnwhitington @kit-ty-kate @metanivek @mndrix @omnisci3nce
  @purplearmadillo77 @rjbou]
* Improve and extended tests [#4159 #4523 #4841 #4859 #4861 #4866 #4915 #4918
  #4963 #4967 #4974 #4975 #4979 #5004 #5006 #5007 #5015 #5024 #5027 #5031 #5081
  #5097 #5101 #5106 #5131 #5143 #5160 #5171 #5176 #5181 #5203 #5208 #5214 #5228
  #5229 #5236 #5253 #5257 #5258 #5261 #5262 #5268 #5270 #5301 #5303 #5304 #5315
  #5325 #5329 #5336 #5356 #5385 #5386 #5402 #5476 #5525 #5538 #5574 #5577 #5578
  @AltGr @cannorin @dra27 @kit-ty-kate @rjbou]
* Improve test engine: Cram tests [#4913 #4966 #4979 #5009 #5004 #5019 #5252
  #5031 #4910 #5024 #5143 #5179 #4892 #5285 #5257 #5308 #5572 @AltGr 
  @kit-ty-kate @rjbou]
* Improve Github actions: [#4729 #4773 #4788 #4865 #4865 #4922 #4966 #5010
  #5067 #5067 #5090 #5153 #5218 #5281 #5365 #5410 @AltGr @dra27 @kit-ty-kate
  @rjbou]

2.1.5:
* [BUG] Variables are now expanded in build-env (as for setenv) [#5352 @dra27]
* Correctly handle empty environment variable additions [#5350 @dra27]
* Skip empty environment variable additions [#5350 @dra27]
* [BUG] Fix passing `archive-mirrors` field from init config file to config
  [#5315 @hannesm]
* git, hg: Use the full SHA1 revision instead of just the 8 first characters
  [#5342 @reynir]
* [BUG] Fix opam installing packages without checking their checksum when the
  local cache is corrupted in some case [#5538 @kit-ty-kate]

2.1.4:
* Add support for OCaml 5.0. Dose3 >= 6.1 and base64 >= 3.1.0 are now required [#5357 @kit-ty-kate @dra27 - fix #5354]
* [BUG] Fix all empty conflict explanation messages [#5378 @kit-ty-kate - partial fix #4373]

2.1.3:
* [BUG] Fix `opam init` and `opam init --reinit` when the `jobs` variable has
  been set in the opamrc or the current config. [#5056 @rjbou]
* When inferring a 2.1+ switch invariant from 2.0 base packages, don't filter
  out pinned packages as that causes very wide invariants for pinned compiler
  packages [#5176 @dra27 - fix #4501]
* [BUG] Fix an internal error on repository upgrade from OPAM 1.2
  [#4965 @AltGr]
* Some optimisations to `opam list --installable` queries combined with other
  filters [#4882 @AltGr - fix #4311]
* Improve performance of some opam list combinations (e.g. `--available`,
  `--installable`) [#4999 @kit-ty-kate]
* Improve performance of `opam list --conflicts-with` when combined with other
  filters [#4999 @kit-ty-kate]
* Improve performance of `opam show` by as much as 300% when the package to
  show is given explicitly or is unique [#4998 @kit-ty-kate - fix #4997 and
  partially #4172]
* [BUG] `opam var` no longer fails if no switch is set
  [#5027 @rjbou - fix #5025]
* [BUG] Setting a variable with option `--switch <sw>` fails instead of writing
  an invalid `switch-config` file [#5027 @rjbou]
* When a field is defined in switch and global scope, try to determine the
  scope also by checking switch selection [#5027 @rjbou]
* [BUG] Handle external dependencies when updating switch state pin status (all
  pins), instead as a post pin action (only when called with `opam pin`
  [#5047 @rjbou - fix #5046]
* [BUG] When reinstalling a package that has a dirty source, if uncommitted
  changes are the same than the ones stored in opam's cache, opam consider that
  it is up to date and nothing is updated [4879 @rjbou]
* Stop Zypper from upgrading packages on updates on OpenSUSE
  [#4978 @kit-ty-kate]
* Clearer error message if a command doesn't exist
  [#4971 @kit-ty-kat - fix #4112]
* [BUG] Remove windows double printing on commands and their output
  [#4940 @rjbou]
* Actually allow multiple state caches to co-exist
  [#4934 @dra27 - actually fixes #4554]
* Update cold compiler to 4.13 to avoid issues with glibc 2.34 on Unix
  [#5017 @dra27]
* Bump opam-file-format to 2.1.4 [#5117 @kit-ty-kate - fix #5116]
* Fix some empty conflict explanations
  [#4982 @kit-ty-kate - partially fix #4373]
* Port some tests from master [#4841 #4974 #4861 #4915 #4979 #5004 #5006 #5015
  #5024 #5025 #5031 #5131 #5176 @AltGr @dra27 @kit-ty-kate]
* Update test engine to allow for additional tests [#4913 #4966 #4979 #5004
  #5009 #5024 #5097 @AltGr @kit-ty-kate @rjbou]
* Update for git protocol deprecation on GitHub [#5097 @rjbou]
* When building opam, do not fail if curl/wget is missing [#5223 #5233 @kit-ty-kate]

2.1.2:
* Fallback on dnf if yum does not exist on RHEL-based systems [#4825 @kit-ty-kate]
* Use --no-depexts in CLI 2.0 mode [#4908 @dra27]
* bootstrap: update ocaml version (fixes the compilation of opam with mingw) [#4927 @kit-ty-kate]

2.1.1:
* Fix typo in error message for opam var [#4786 @kit-ty-kate - fix #4785]
* Run the sandbox check in the temporary directory [#4787 @dra27 - fix #4783]
* OpamSystem: avoid calling Unix.environment at top level [#4789 @hannesm]
* Homebrew: Add support for casks and full-names [#4801 @kit-ty-kate]
* Fix the cold target in presence of an older OCaml compiler version on macOS
  [#4802 @kit-ty-kate - fix #4801]
* Archlinux: handle virtual package detection [#4833 @rjbou - partial fix #4759]
* Disable the detection of available packages on RHEL-based distributions.
  This fixes an issue on RHEL-based distributions where yum list used to detect
  available and installed packages would wait for user input without showing
  any output and/or fail in some cases [#4791 @kit-ty-kate - fixes #4790]
* Handle empty environment variable updates - missed cherry-pick from 2.0
  [#4840 @dra27]
* Fix vendored build on mingw-w64 with g++ 11.2 [#4835 @dra27]
* Put back support for switch creation with packages argument and
  `--packages` option with cli 2.0, and a specific error message for cli 2.1
  [#4853 @rjbou - fix #4843]
* Fix reverting environment additions to PATH-like variables when several dirs
  added at once [#4861 @dra27]
* Fix dose3 download url since gforge is gone [#4870 @avsm]
* Ensure setenv can use package variables defined during the build
  [#4841 @dra27]
* Fix `set-invariant`: default repos were loaded instead of switch repos
  [#4869 @rjbou]

2.0.10:
* Fix reverting environment additions to PATH-like variables when several dirs
  added at once [#4861 @dra27]
* Ensure setenv can use package variables defined during the build
  [#4841 @dra27]

2.1.0:
* Set DEBIAN_FRONTEND=noninteractive for unsafe-yes confirmation level
  [#4735 @dra27 - partially fix #4731]
* Fix 2.1~alpha2 to 2.1 format upgrade with reinit [#4750 #4756 @rjbou - fix #4748]
* Fix bypass-check handling on reinit [#4750 @rjbou]
* fish: fix deprecated redirection syntax `^` [#4736 @vzaliva]
* Bump src_exts and fix build compat with Dune 2.9.0 [#4754 @dra27]
* Fix depext alpine tagged repositories handling [#4758 @rjbou]

2.0.9:
* Fix the conflict with the environment variable name used by dune
  [#4535 @smorimoto - fix ocaml/dune#4166]
* Kill builds on Ctrl-C with bubblewrap [#4530 @kit-ty-kate - fix #4404]
* Linux: mount existing TMPDIR read-only, re-bind `$TMPDIR` to a separate tmpfs
  [#4589 @AltGr]
* Fix the sandbox check [#4589 @AltGr]
* Fix sandbox script shell mistake that made `PWD` read-write on remove actions
  [#4589 @AltGr]
* Port bwrap improvements to sandbox_exec [#4589 #4609 @AltGr]
* Fix W59 & E60 with conf flag handling (no url required) [#4550 @rjbou - fix #4549]
* Fix temporary file with a too long name causing errors on Windows
  [#4590 @AltGr]
* Switch to newer version of MCCS (based on newer GLPK) for src_ext
  [#4559 @AltGr]
* Fix version pin source retrieving: don't error if archive opam file is
  malformed [#4580 @rjbou]
* Release scripts: switch to OCaml 4.10.2 by default, add macos/arm64 builds by
  default [#4559 @AltGr]
* Fix opam-devel's tests on platforms without openssl, GNU-diff and a
  system-wide ocaml [#4500 @kit-ty-kate]
* Untag dune as a build dependency [#4229 @kit-ty-kate]
* Fix configure check in github actions [#4593 @rjbou]
* Add missing shell quoting to support space and special shell characters in
  switch directory path [#4707 @kit-ty-kate]
* The options `--root` and `--switch` are now reflected in environment
  variables when building packages so that calls to `opam` during build access
  the correct root and switch [#4668 @LasseBlaauwbroek]
* If opam root is different from the binary, allow reading it and try to read
  in best effort mode [#4638 @rjbou - fix #4636]
* Differentiate bad format from bad (opam) version with `Bad_version`
  exception, raised from `OpamFormat.check_opam_version` [#4638 @rjbou]
* Add `BestEffort` modules with reading functions that don't show errors, given
  the `opam_file_format` internal field [#4638 @rjbou - fix
* Require opam-file-format 2.1.3+ in order to enforce opam-version: "2.1" as
  first non-comment line [#4639 @dra27 - fix #4394]
* Fix opam switch creation not compatible compiler message
  [#4547 @rjbou - fix #4718]
* fish: fix deprecated redirection syntax `^` [#4736 @vzaliva]
* Fix `opam-version' field reading in new roots [#4742 @dra27 @rjbou]

2.1.0~rc2:
* Remove OPAMZ3DEBUG evironment variable [#4720 @rjbou - fix #4717]
* Fix format upgrade when there is missing local switches in the config file
  [#4715 @rjbou - fix #4713]
* Fix not recorded local switch handling, with format upgrade [#4715 @rjbou]
* Set opam root version to 2.1 [#4715 @rjbou]
* Improved and extended tests [#4715 @rjbou]

2.1.0~rc:
* (*) Environment variables initialised only at opam client launch, no more via
  libraries [#4606 #4703 @rjbou]
* (*) Deprecated `build-doc`, `build-test`, `make` flags [#4581 @rjbou]
* (+) Add `--confirm-level` and `OPAMCONFIRMLEVEL` for automatic answering
  [#4582 @rjbou - fix #4168; #4683 @dra27 - fix #4682; #4691 @rjbou - fix #4682]
* (+) Add `--no` [#4582 @rjbou]
* (+) Add a `--with-0install-solver` option to the configure script to enable
  the 'builtin-0install' solver [#4646 @kit-ty-kate]
* Add default cli mechanism: deprecated options are accepted (in the major
  version) if no cli is specified [#4575 @rjbou]
* Add `opam config` deprecated subcommands in the default cli
  [#4575 @rjbou - fix #4503]
* Add cli versioning for opam environment variables [#4606 @rjbou]
* Add cli versioning for enums of flags with predefined enums [#4606 @rjbou]
* Clearer messages about using --cli and OPAMCLI [#4655 @dra27]
* The options `--root` and `--switch` are now reflected in environment
  variables when building packages so that calls to `opam` during build access
  the correct root and switch [#4668 @LasseBlaauwbroek]
* Add cli versioning for enums of flags with predefined enums [#4626 @rjbou]
* Preprocess `--confirm-level` for plugins calls/install [#4694 @rjbou]
* Ensure the symlink for a plugin is maintained on each invocation
  [#4621 @dra27 - partially fixes #4619]
* Initialise environment variables for plugins call/install [#4582 @rjbou]
* Expect plugins to end in .exe on Windows [#4709 @dra27]
* Introduce a `default-invariant` config field, restore the 2.0 semantics for
  `default-compiler` [#4607 @AltGr]
* Fix default invariant with no system compiler [#4644 @AltGr - fix #4640]
* Perform an hard upgrade on intermediate roots, ie root from `2.1~alpha/beta`,
  and keep a light upgrade from `2.0` [#4638 @rjbou]
* Send the 'opam root layout update' message to stderr [#4692 @AltGr]
* If opam root is different from the binary, allow reading it and try to read
  in best effort mode [#4638 @rjbou - fix #4636]
* Don't check opam system dependencies on reinit after a format upgrade
  [#4638 @rjbou]
* Fix `sys-ocaml-cc`, `sys-ocaml-arch` and `sys-ocaml-libc` when no system
  compiler installed [#4706 @dra27]
* Fix `Not_found` (config file) in config report [#4570 @rjbou]
* Config report: Print variables of installed compilers and their (installed)
  dependencies [#4570 @rjbou]
* Don't patch twice file [#4529 @rjbou]
* With `--deps-only`, set dependencies as root packages
  [#4964 @rjbou - fix #4502]
* Keep global lock only if root format upgrade is performed
  [#4612 @rjbou - fix #4597]
* Improve installation times by only tracking files listed in `.install`
  instead of the whole switch prefix when there are no `install:` instructions
  (and no preinstall commands)
  [#4494 @kit-ty-kate @rjbou; #4667 @dra27 - fix #4422]
* Scrub OPAM* environment variables added since 2.0 from package builds to
  prevent warnings when a package calls opam [#4663 @dra27 - fix #4660]
* Correct the message when more than one depext is missing [#4678 @dra27]
* Only display one conflict message when they are all owing to identical
  missing depexts [#4678 @dra27]
* Don't exclude base packages from rebuilds (made some sense in opam 2.0 with
  base packages but doesn't make sense with 2.1 switch invariants) [#4569 @dra27]
* Don't refer to base packages in messages any more
  [#4623 @dra27 - fixes #4572]
* Give the correct command when demonstrating switch creation
  [#4675 @dra27 - fixes #4673]
* On switch loading, if invariant is inferred and a write lock required, write
  the file [#4638 @rjbou]
* Don't look for lock files for pin depends [#4511 @rjbou - fix #4505]
* Fetch sources when pinning an already pinned package with a different url
  when using working directory [#4542 @rjbou - fix #4484]
* Don't ask for confirmation for pinning base packages (similarly makes no
  sense with 2.1 switch invariants) [#4571 @dra27]
* Fix version pin source retrieving: mustn't error if archive opam file is
  malformed [#4580 @rjbou]
* `opam list --silent` renamed to `--check` [#4595 @dra27 - fix #4323]
* Include doc field in opam-show [#4567 @dra27 - partially fix #4565]
* Fix `switch` global variable resolving [#4685 @rjbou - fix #4684]
* Fix `hash` package variable resolving [#4687 @rjbou]
* Lint: Fix W59 & E60 for conf packages (no url required)
  [#4550 @rjbou - fix #4549]
* Lint: Fix W59 & E60 with VCS urls, don't check upstream if url has VCS
  backend [#4635 @rjbou]
* Lint: Add E67 checksum specified with non archive url [#4635 @rjbou]
* Lint: Disable subpath warning E63,W64 [#4638 @rjbou]
* Lint: Fix manpage listing [#4708 @rjbou]
* Don't write lock file with `--read-only', `--safe`, and `--dryrun`
  [#4562 @rjbou - fix #4320]
* Make `opam lock` consistent with `opam install`, on local pin always take
  last opam file even if uncommitted [#4562 @rjbou - fix #4320]
* Opam file: Fix `features` parser [#4507 @rjbou]
* Opam file: Rename `hidden-version` to `avoid-version` [#4527 @dra27]
* Opam file: Fix rewriting with preserved format empty field error
  [#4634 @rjbou - fix #4628]
* Opam file: Switch config: Defined `invariant` field as an option to
  differentiate when it is not defined [#4638 @rjbou]
* Opam file: Differentiate bad format from bad (opam) version with
  `Bad_version` exception, raised from `OpamFormat.check_opam_version`
  [#4638 @rjbou]
* Opam file: Always print the `opam-version` field on files [#4638 @rjbou]
* Opam file: Config: add `opam-root-version` field as a marker for the whole
  opam root [#4638 @rjbou - fix #4636]
* Opam file: Add `BestEffort` modules with reading functions that don't show
  errors, given the `opam_file_format` internal field [#4638 @rjbou - fix #4636]
* Depext: Handle macport variants [#4509 @rjbou - fix #4297]
* Depext: Always upgrade all the installed packages when installing a new
  package on Archlinux [#4556 @kit-ty-kate]
* Depext: Handle some additional environment variables (`OPAMASSUMEDEPEXTS`,
  `OPAMNODEPEXTS`) [#4587 @AltGr]
* Depext: Improve messages to hint that answering `no` doesn't abort
  installation [#4591 @AltGr]
* Depext: Add support for non-interactive mode in macports [#4676 @kit-ty-kate]
* Depext: Handling of packages of tagged repositories for alpine
  [#4700 @rjbou - fix #4670]
* Depext: Clarify some `assume-depexts` related messages
  [#4671 @AltGr - partial fix #4662]
* Depext: Warn the user if epel-release is missing and unavailable depexts are
  detected [#4679 @dra27 fix #4669]
* Depext: Ignore config yes automatic answering when asking confirmation to run
  install commands [#4698 @rjbou - fix #4680]
* Sandbox: Fix the conflict with the environment variable name used by dune
  [#4535 @smorimoto - fix ocaml/dune#4166]
* Sandbox: Kill builds on Ctrl-C with bubblewrap
  [#4530 @kit-ty-kate - fix #4400]
* Sandbox: Linux: mount existing TMPDIR read-only, re-bind `$TMPDIR` to a
  separate tmpfs [#4589 @AltGr]
* Sandbox: Fix the sandbox check [#4589 @AltGr]
* Sandbox: Fix sandbox script shell mistake that made `PWD` read-write on
  remove actions [#4589 @AltGr]
* Sandbox: Port bwrap improvements to sandbox_exec [#4589 @AltGr]
* Sandbox: Fix realpath use for macos, partial revert of #4589 [#4609 @AltGr]
* Add missing shell quoting to support space and special shell characters in
  switch directory path [#4707 @kit-ty-kate]
* Rename `state.cache` to include the `OpamVersion.magic()` string. All .cache
  files are deleted if any cache file is written to, allowing multiple versions
  of the library to co-exist without constantly regenerating it
  [#4642 @dra27 - fix #4554]
* Fix Cudf preprocessing [#4534 #4627 @AltGr - fix #4624]
* Allow to upgrade to a hidden-version package if a hidden-version package is
  already installed [#4525 @kit-ty-kate]
* Add support for a few select criteria useful to CI to the 0install solver:
  `+count[version-lag,solution]` to always choose the oldest version available,
  `+removed` to not try to keep installed packages [#4631 @kit-ty-kate]
* Fix opam-devel's tests on platforms without openssl, GNU-diff and a
  system-wide ocaml [#4500 @kit-ty-kate]
* Use dune to run reftests [#4376 @emillon]
* Restrict `extlib` and `dose` version [#4517 @kit-ty-kate]
* Restrict to `opam-file-format.2.1.2` [#4495 @rjbou]
* Require `opam-file-format.2.1.3+` in order to enforce `opam-version: "2.1"`
  as first non-comment line [#4639 @dra27 - fix #4394]
* Switch to newer version of MCCS (based on newer GLPK) for src_ext
  [#4559 @AltGr]
* Bump dune version to 2.8.2 [#4592 @AltGr]
* Bump the minimal dune requirement to dune 1.11 [#4437 @dra27 @kit-ty-kate]
* 4.12 compatibility [#4437 @dra27 @kit-ty-kate]
* Cold compiler updated to 4.12 [#4616 @dra27]
* Fix build from source when a dune-project file is presented in the parent
  directory [#4545 @kit-ty-kate]
* Fix build from source when a dune-project file is presented in the parent
  directory [#4545 @kit-ty-kate - fix #4537]
* Fix opam-devel.install not to install two files called opam [#4664 @dra27]
* Build release tags as non-dev versions, as for release tarballs
  [#4665 @dra27 - fix #4656]
* Disable dev version for tests (needed for format upgrade test) [#4638 @rjbou]
* Add a hint for missing `openssl` in `make cold` [#4702 @rjbou]
* Remove test field from opam-devel, they need the network [#4702 @rjbou]
* Update src_ext for Dune and MCCS [#4704 @dra27]
* Release scripts: switch to OCaml 4.10.2 by default, add macos/arm64 builds by
  default [#4559 @AltGr]
* Release scripts: add default cli version check on full archive build
  [#4575 @rjbou]
* Arg: Generalise `mk_tristate_opt` to `mk_state_opt` [#4575 @rjbou]
* Arg: Fix `mk_state_opt` and rename to `mk_enum_opt` [#4626 @rjbou]
* Arg: Add `mk_enum_opt_all` for state flags that appears more than once
  [#4582 @rjbou]
* Fix `opam exec` on native Windows when calling cygwin executables
  [#4588 @AltGr]
* Fix temporary file with a too long name causing errors on Windows
  [#4590 @AltGr]
* CLI: Add flag deprecation and replacement helper [#4595 @rjbou]
* Win32 Console: fix VT100 support [#3897 #4710 @dra27]
* Tidied the opam files [#4620 @dra27]
* Externalise cli versioning tools from `OpamArg` into `OpamArgTools`
  [#4606 @rjbou]
* Each library defines its own environment variables, that fills the config
  record [#4606 @rjbou]
* Harden cygpath wrapper [#4625 @dra27]
* Reset the plugin symlinks when the root is upgraded
  [#4641 @dra27 - partial fix for #4619]
* Formalise opam dev version detection with `OpamVersion.is_dev_version`
  [#4665 @dra27]
* Add `OpamStd.String.is_prefix_of` [#4694 @rjbou @dra27]
* Fix `OpamStd.Format.pretty_list`: `last` argument dropped if list contains
  more than 2 elements [#4694 @rjbou]
* Run the shell hooks with closed stdin (bash, zsh) [#4692 @AltGr]
* Improved and extended tests
  [#4376 #4504 #4545 #4612 #4668 #4612 #4634 #4672 #4638 #4702 #4697 #4697
  @AltGr @dra27 @emillon @rjbou]
* Improve Github Actions
  [#4593 #4575 #4610 #4610 #4618 #4606 #4695 #4695 @AltGr @dra27 @rjbou]
* Improve documentation
  [#4496 #4506 #4513 #4637 #4681 #4702
  @dannywillems @eth-arm @kit-ty-kate @rjbou @UnixJunkie]

2.0.8:
* Add colon for fish MANPATH fix. [#4084 @rjbou - fix #4078]
* No error when linked directory doesn't exist (e.g. XDG defined)
  [#4278 @kit-ty-kate]
* Add quotes to avoid space unwanted behaviors [#4278 @kit-ty-kate]
* Handle `CCACHE_DIR` environment variable in sandbox script.
  [#4087 @rjbou - fix #4079]
* Follow links of `~/.cache` & `~/.cache/dune` for bwrap call.
  [#4087 @rjbou - fix #4086]
* Don't overwrite user's sandbow script modification. [#4020 #4092 @rjbou]
* On MacOS sandbox script, always read write mount `/tmp`
  [#3742 @rjbou - fix ocaml/opam-repository#13339]
* Use version var in opam file instead of equal current version number in
  opamlib dependencies [#4178 @rjbou]
* Opam file build using dune [#4178 @rjbou #4229 @kit-ty-kate - fix #4173]
* Update opam file to 2.0 [#4371 @AltGr]
* Fix `arch` detection when using 32bit mode on ARM64 [#4462 @kit-ty-kate]
* Fix `arch` detection of i486 [#4462 @kit-ty-kate]
* The stdout of pre- and post-session hooks is now propagated to the user
  [#4382 @AltGr - fix #4359]
* Run switch pre/post sessions hooks [#4476 @rjbou - fix #4472]

2.1.0~beta4:
* (*) Implemented CLI version compatibility layer [#4385 @rjbou]
* (*) Return code 31 (`Sync_error`) instead of code 40
  (`Package_operation_error`) when all failures happend during fetching
  [#4416 @rjbou - fix #4214]
* (+) Add `--download-only` flag [#4071 @Armael @rjbou - fix #4036]
* (+) Provide `opam update --depexts` to request an update of the system package manager databases [#4379 @AltGr - fix #4355]
* Set OPAMCLI=2.0 during package action commands [#4492 @kit-ty-kate]
* Fix sandbox check on first `opam init` [#4370 @rjbou - fix #4368]
* Print shell-appropriate eval command on `opam init` [#4427 @freevoid]
* Fix init script check in csh [#4482 @gahr]
* The stdout of `pre-` and `post-session` hooks is now propagated to the user [#4382 @AltGr - fix #4359]
* `post-install` hooks are now allowed to modify or remove installed files [#4388 @lefessan]
* Add support for switch-specific pre/post sessions hooks [#4476 @rjbou - fix #4472]
* Ensure we don't advertise upgrades to hidden versions [#4477 @AltGr - fix #4432]
* Fix `opam remove --autoremove <PKG>` to not autoremove unrelated packages [#4369 @AltGr - fix #4250 #4332]
* Fix cases where `opam remove -a` could trigger conflicts in the presence of orphan packages [#4369 @AltGr - fix #4250 #4332]
* Fix `--update-invariant` when removing or changing package name [#4360 @AltGr - fix #4353]
* Fix updates of the invariant with `--update-invariant` [#4431 @AltGr]
* Fix cleanup of build dirs for version pinned packages [#4436 @rjbou - fix #4255]
* Fix opamfile format upgrade on pinning [#4366 @rjbou - fix #4365]
* Fix `pin --show` actually pinning [#4367 @rjbou - fix #4348]
* When several pins are needed, do their fetching in parallel [#4399 @rjbou - fix #4315]
* Don't cleanup VCS pin source directories [#4399 @rjbou]
* Fix `--working-dir` with local switches [#4433 @rjbou]
* Add package variable `opamfile-loc`, containing the location of installed package opam file [#4402 @rjbou]
* Fix `arch` detection when using 32bit mode on ARM64 [#4462 @kit-ty-kate]
* Fix `arch` detection of i486 [#4462 @kit-ty-kate]
* Skip loading the switch state for variable lookup when possible [#4428 @rjbou]
* Fix package variables display when no config file is found [#4428 @rjbou]
* Fix `opam option depext-bypass-=["XXX"]` [#4428 @rjbou]
* Lint: add a check that strings in filtered package formula are booleans or variables [#443 @rjbou - fix #4439]
* Fix handling of filename-encoded pkgname in opam files [#4401 @AltGr - fix ocaml-opam/opam-publish#107]
* Don't recompile when modifying the package flags [#4477 @AltGr]
* Add depext support for NetBSD and DragonFlyBSD [#4396 @kit-ty-kate]
* Fix depexts on OpenBSD, FreeBSD and Gentoo: Allow short names and full name paths for ports-based systems [#4396 @kit-ty-kate]
* Handle the case where `os-family=ubuntu` as `os-family=debian` [#4441 @alan-j-hu]
* Update opam's opam files to 2.0 [#4371 @AltGr]
* Makefile: Add rule `custom-libinstall` for `opam-custom-install` use [#4401 @AltGr]
* Use the archive caches when running `opam admin cache` [#4384 @AltGr - fix #4352]
* Fix explosion of `opam admin check --cycles` on repositories with huge cliques [#4392 @AltGr]
* Much improved format-preserving printer [#4298 #4302 @rjbou - fix #3993]
* Fix missing conflict message when trying to remove required packages [#4362 @AltGr]
* Fix the Z3 backend for upgrades [#4393 @AltGr]
* Fix cases where opam would wrongly complain about action cycles [#4358 @AltGr - fix #4357]
* Fix permission denied fallback for openssl [#4449 @Blaisorblade - fix #4448]
* Add debug & verbose log for patch & subst applications [#4464 @rjbou - fix #4453]
* Be more robust w.r.t. new caches updates when `--read-only` is not used [#4467 @AltGr - fix #4354]
* Improved and extended tests [#4375 #4395 #4428 #4385 #4467 #4475 #4483 @emillon @rjbou @AltGr @freevoid @dra27]
* Switched to Github actions [#4463 @rjbou]

2.1.0~beta2:
* Reduced startup times, in particular for `opam exec` [#4341 @altgr]
* Fixed the sandboxing check on fresh inits [#4342 @altgr]
* Fixed cases where `--with-version` was not respected by `opam pin` [#4346 @altgr]
* Upgraded the bootstrap OCaml compiler from 4.09.1 to 4.11.1 [#4242 @avsm @dra27 @MisterDA @rjbou]

2.1.0~beta:
* (*) `--cli` / `OPAMCLI` option added [#4316 @dra27]
* `--help/--version` documented in wrong section for aliases [#4317 @dra27]
* `opam lock --help` missing common information {#4317 @dra27]
* (+) `--yes` passed to all commands, and plugins [#4316 @dra27]
* On init, check availability of sandbox and propose to disable
  [#4284 @rjbou - fix #4089]
* config upgrade: on the fly upgrade if no write lock required [#4313 @rjbou]
* (*) Add `pin scan` subcommand to list available pins [#4285 @rjbou]
* (*) Add `--normalise` option to print a normalised list when scanning, that can
  be taken by `opam pin add` [#4285 @rjbou]
* (*) Add `with-version` option to set the pinned package version [#4301 @rjbou]
* Add error message in case git repo is empty [#4303 @rjbou - fix #3905]
* Lock: Support -d as alias of --direct-only (to match plugin) [#4319 @dra27]
* Switch: Support -n as an alias of --no-action (to match opam-pin)
  [#4324 @dra27]
* List: <field> form no longer advertised as valid for --columns [#4322 @dra27]
* Admin: <field> form no longer advertised as valid for --columns in list
  [#4322 @dra27]
* Solver: Don't penalise packages with more recent 'hidden-versions'
  [#4312 @AltGr]
* `OpamCommand.pin` refactor, including adding `OpamClient.PIN.url_pins` to pin
  a list of package with url  [#4285 #4301 @rjbou]
* `OpamPinCommand.source_pin', for new package confirmation, don't check that
  no opam file is given as argument [#4301 @rjbou]
* CLI: Provide all functions in the client library [#4329 @AltGr]
* Process: don't display status line if not verbose, and status line disabled
  [#4285 @rjbou]
* Optimise package name comparison [#4328 @AltGr - fix #4245]

2.1.0~alpha3:
* Confirmation on non-compiler switch invariant: not on dryrun, Y by default
  [#4289 @AltGr]
* (*) Fix pin kind automatic detection consistency [#4300 @rjbou]: With `opam
  pin target', when opam file is not versioned and at root, vcs-pin the package
  instead of path-pin, and with `opam pin add nv target', take opam file even
  if not versioned.
* External dependencies: Fix non-interactive mode on OpenSuse [#4293
  @kit-ty-kate]
* src-ext: bump topkg to 1.0.2 and dune to 2.6.2, with a second compiler
  built in case main one is < 4.07.0 (dune restriction) [#4294 @dra27]
* Allow Z3 backend to return sub-optimal solutions on timeout, add
  `OPAMSOLVERALLOWSUBOPTIMAL` environment variable [#4289 @AltGr]
* Add an optional solver relying on opam-0install-cudf [#4240 @kit-ty-kate]

2.1.0~alpha2:
* Remove m4 from the list of recommended tools [#4184 @kit-ty-kate]
* Fix config solver field ignored at init [#4243 @rjbou - fix #4241]
* Fix atoms formula restriction with `--all` at upgrade [#4221 @rjbou - fix
  #4218]
* Copy instead of calling rsync when archives are in a local cache [#4270
  @kit-ty-kate]
* Opam file build using dune, removal of opam-%.install makefile target
  [#4178 @rjbou #4229 @kit-ty-kate - fix #4173]
* Use version var in opam file instead of equal current version number in
  opamlib dependencies [#4178 @rjbou]
* src ext: fix extlib url [#4248 @rjbou]
* Add `_build` to rsync exclusion list [#4230 @rjbou - fix #4195]
* Recursive opam file lookup: ignore `_build` [#4230 @rjbou]
* Assume-built fix & rewriting [#4211 @rjbou]
* Fix autoremove env var handling [#4219 @rjbou - fix #4217]
* Fix Not_found with `opam switch create . --deps` [#4151 @AltGr]
* Package Var: resolve self `name` variable for orphan packages [#4228 @rjbou
  - fix #4224]
* (*) Reject (shell) character on switch names [#4237 @rjbou - fix #4231]
* Fix `OPAMSWITCH` empty string setting, consider as unset [#4237 @rjbou]
* opam-installer: For paths, remove use of empty switch in favor of a
  context-less module [#4237 @rjbou]
* Add missing depext to unavailable reasons [#4194 @rjbou #4279 @rjbou - fix
  #4176]
* (*) Bump config file version to 2.1 (new depext fields) [#4280 @rjbou - fix
  #4266]
* Add depext handling on new pinned packages [#4194 @rjbou - fix #4189]
* Don't keep unpinned package version if it exists in repo [#4073 @rjbou -
  fix #3630]
* Fix path resolving when pinning with `file://` [#4209 @rjbou - fix #4208]
* (*) Disable recursive & subpath pinning (only present experimentally in opam
  2.1.0~alpha) [#4252 @rjbou]
* Add switch depext-bypass as modifiable field [#4194 @rjbou - fix #4177]
* Add `--no-depexts` option to disable depexts packages unavailability [#4194
  @rjbou - fix #4205]
* Warn if packages are not listed because of depexts unavailability [#4194
  @rjbou - fix #4205]
* (*) Display error message for all not found packages [#4179 @rjbou - fix
  #4164]
* (*) Keep package order given via cli [#4179 @rjbou - fix #4163]
* `--sort`` apply to with all options, not only `--just-file` [#4179 @rjbou]
* Add scope display to Not found message [#4192 @rjbou]
* No scope needed for variable display [#4192 @rjbou - fix #4183]
* Fix package variable resolution [#4192 @rjbou - fix #4182]
* opam option: Fix messages advertising a command in an obsolete format
  [#4194 @rjbou]
* E65: check that url local paths are absolute [#4209 @rjbou]
* Fix arch query depext [#4200 @rjbou]
* Add message when adding a package to `depext-bypass` [#4194 @rjbou]
* Fix performance issue of depext under Docker/debian [#4165 @AltGr]
* Handle debian virtual packages [#4269 @AltGr @rjbou - fix #4251]
* Refactor `OpamSysInteract` package status [#4152 #4200 @rjbou]
* Add environment variables handling on depext query [#4200 @rjbou]
* Add depext Macport support [#4152 @rjbou]
* Homebrew/depext: add no auto update env var for install, accept `pkgname`
  and `pkgname@version` on query [#4200 @rjbou]
* Tag packages with missing depexts in Cudf [#4235 @AltGr]
* Force LC_ALL=C for depext query commands [#4200 @rjbou]
* Put back opam-depext-2.0's behaviour with regards to asking users' consent
  before installing system packages [#4168 @kit-ty-kate @rjbou]
* Add OPAMDEPEXTYES env variable to pass --yes options to system package
  manager [#4168 @kit-ty-kate @rjbou]
* Fix system install command dryrun [#4200 @rjbou]
* (+) Add --depext-only to install only external dependencies, regardless of
  config depext status [#4238 @rjbou]
* Move system install confirmation message after opam packages install [#4238
  @rjbou]
* Error if '--depext-only' is given with '--assume-depexts' or '--no-depexts'
  [#4238 @rjbou]
* Sanddbox: no error when linked directory doesn't exist (e.g. XDG defined)
  [#4278 @kit-ty-kate]
* Sandbox: add quotes to avoid space unwanted behaviors [#4278 @kit-ty-kate]
* Fix temp files repository cleaning [#4197 @rjbou]
* Fix admin cache synchronisation message [#4193 @rjbou - fix #4167]
* Fix mismatching extra files detection [#4198 @rjbou]
* Fix Cudf generation for compat with external solvers [#4261 @AltGr]
* Check for a solution before calling the solver [#4263 @AltGr]
* Add the package flag 'hidden-version' to discourage selection by the solver
  [#4281 @AltGr]
* Tweak the default criteria to handle 'missing-depexts' and 'hidden-version'
  flags [#4281 @AltGr]
* Disable chrono when timestamps are disables [#4206 @rjbou]
* Expose some functionality in the `OpamAction`, `OpamPath` and
  `OpamSwitchState` modules for use without a `switch` value (introduce a
  functor to permit replicating switch layout in different contexts) [#4147
  @timberston]
* Std: Add map_reduce to Set and Map [#4263 @AltGr]
* Fix regression in command resolution from #4072 (ocaml code for looking up
  commands in PATH) [#4265 @dra27]
* Use OCaml 4.09.1 for the make cold target [#4257 @dra27]
* Add show cram test [#4206 @rjbou]
* Add envrionnement variable handling on cram test [#4206 @rjbou]


2.1.0~alpha:
* Recursive & subpath based pin [#3499 @rjbou @hngrgr - fix #3174 #3477]
* Define switch invariants rather than "base packages" [#3894 @AltGr]
* Don't warn on switch creation with 'ocaml' as invariant [#4108 @AltGr]
* Better error handling on switch creation [#4121 @AltGr]
* Integrate lock plugin [#3746 @rjbou - fix #3734 #3769 #3694]
* Add configuration modifications as opam config subcommands [#3992 @rjbou]
* opam var and opam option outside of opam config [#4116 @rjbou - fix #4119]
* Enable option var optimisation switch load [#4138 @rjbou]
* Integrate depext plugin [#3975 @rjbou @AltGr - fix #3790 #1519 #2426 #3692]
* Enable command/output display only from verbose level 3 [#4141 @rjbou]
* Add `opam install --check <pkg>` checks that `<pkg>` dependencies are already
  installed in the switch. It reports missing ones and exits with 1, 0 otherwise.
  It is used on a check only purpose, additionally to `--deps-only`.
  [#3854 @rjbou - fix #3823]
* Add `opam install <pkg> --ignore-conflicts` to use with `--deps-only` in case
  it is needed to install dependencies without taking conflicts into account.
  [#3853 @rjbou - fix #3846]
* Add `opam show --just-file <file>` shows information of a given file,
  without loading the switch state. It can be combined with other options, as
  field filter `--field`. It deprecates `--file` option. [#3729 @rjbou - fix
  #3721]
* Add `opam show --all-versions <pkg>` displays information of all versions of
  the given package. It can be used in combination of field filter. [#3867 @rjbou
  - fix #2980]
* Add `opam show --sort <pkg>` display on stdout a sorted opam file: all fields
  are alphabetically sorted. [#3866 @rjbou - fix ocaml/opam2web#173]
* opam show better error handling. [#4118 @rjbou - fix #3875]
* `opam show --field` are no longer required to end with a colon.
  [#3931 @rjbou]
* (*) `opam show --normalise` disable terminal width wrapping. [#3868 @rjbou -
  fix #3751]
* `opam env --check` permit to indicates if an opam environment is
  synchronized: returns 0 if up-to-date, 1 otherwise. [#4074 @rjbou - fix #3725]
* Add `opam switch export --freeze` to record VCS commit hash when a VCS url is
  specified. [#4055 @hannesm]
* Add `opam switch export --full` option, include extra-files in switch export,
  on import create an overlay directory with the file contents. [#4040 @hannesm]
* Optimize repository loading: we store the repository contents as .tar.gz
  files in ~/.opam/repo instead. [#3752 @AltGr - fix #3721]
* Handle failure or interruption of tar during `opam update`. [#3861 @AltGr]
* Fallback in case repository archive doesn't exist. [#4008 @rjbou]
* In case repository archive is corrupted, delete it and ask to launch an
  update. [#4075 @rjbou - fix #4053]
* When adding a repository, an error is displayed in case of mismatching urls,
  now both urls are displayed. [#4086 @rjbou - fix #4085]
* Handle url backend change to VCS of a package from repository. [#4007 @rjbou
  - fix #3991]
* Allow local compiler switch creation. [#3720 @rjbou - fix #3713]
* Switch creation, fix multiple compiler candidate. [#3884 @rjbou - fix #3874]
* Make reinstall handling stricter. [#3907 @AltGr]
* (*) `opam list --resolve`: restrain test dependencies to direct one instead of
  listing all test dependencies of queried package(s) [#3923 @rjbou - fix
  ocaml/opam-depext#121]
* Update pin-depends confirmation message to add a skip option. [#3852 @rjbou -
  fix #3840]
* Add OPAMDROPWORKINGDIR environment variable for C. [#3792 @rjbou - fix #3727]
* Don't restrain copy to versioned file. [#3759 @rjbou]
* Don't fetch sources when working-dir is set. [#4046 @rjbou]
* Update in place source copy: [#3948 @rjbou]
  - review `sync_dirty` on VCS:
    - use VCS to synchronize, then rsync & remove others files
    - exclude `_build`, `_opam` & VCS directories
  - when `--inplace-build` is given, it does a dirty synchronization of the
    sources, in order to keep tracking package stats (clean, local or dirty).
* Fix `working-dir` messages on update command. [#3824 @rjbou]
* Working-dir fixes. [#3982 @rjbou]
* Update download errors handling during actions processing. [#3811 @AltGr]
* Update `ftp` command, to pass url last. [#3910 @hannesm]
* Terminate (with double dashes) list of command-line download option.
  [#3913 @cfcs]
* Repository: remove 'file://' prefix for darcs. [#3761 @rjbou]
* Opam{Git,Hg}: Fix diffs in presence of binary file. [#3879 @kit-ty-kate]
* Set core.autocrlf and core.eol for Git remotes. [#3882 @dra27]
* Add a git clean on `reset_tree` to keep source dir clean. [#3948 @rjbou]
* Lint W62: Add a lint check for SPDX license. [#3976 @AltGr]
* Lint: add result in json output. [#3848 @rjbou - fix #3046]
* Add lint codes in manpage. [#3903 @rjbou]
* Default configuration file: add `getconf` to required tools. [#3813 @rjbou]
* Clarify message in `opam init --yes`. [#3892 @dra27]
* Shell setup: don't advice an infinite sourcing loop. [#3832 @rjbou]
* Default configuration file: Add compilation target globals, `sys-ocaml-arch,
  `sys-ocaml-cc`, and `sys-ocaml-libc`. [#3900 @dra27]
* Ensure that environment is initialized lazily, not before init functions are
  called [#4111 @gasche]
* Fix OPAMLOGS handling, and logdir `opam_init` argument [#4117 @rjbou - fix
  #4076]
* Include base packages configuration variables in opam config report.
  [#3798 @dra27]
* Determine jobs number at launch (`OpamStateConfig`) [#4004 @rjbou - fix
  #3986]
* Fully test native Windows in the testsuite. [#3260 @dra27]
* Allow native Windows to use Cygwin tool. [#3348 @dra27]
* Deal with Windows path conventions (backslashes, .exe, etc.) [#3350 @dra27]
* Correct display of dir separator on Windows. [#3893 @dra27]
* Tested wrong variable in OPAMW_HasGlyp. [#3898 @dra27]
* Default use `fetch` on FreeBSD, `ftp` on OpenBSD. [#3904 @hannesm]
* Don't overwrite user's sandbow script modification. [#4020 #4092 @rjbou]
* Handle `CCACHE_DIR` environment variable in sandbox script. [#4087 @rjbou -
  fix #4079]
* Follow links of `~/.cache` & `~/.cache/dune` for bwrap call. [#4087 @rjbou -
  fix #4086]
* On MacOS sandbox script, always read write mount `/tmp` [#3742 @rjbou - fix
  ocaml/opam-repository#13339]
* Environment file right handling for empty switch. [#3899 @dra27]
* Add colon for fish MANPATH fix. [#4084 @rjbou - fix #4078]
* Update zsh check interactive terminal [#4095 @OCamlPro-mattiasdrp #4128
  @AltGr]
* Add package selection to `opam admin add-hashes` [#3787 @rjbou - fix #3767]
* Download files (patches, etc.) using a safe filename. [#3900 @dra27]
* `opam admin --add-constraints`, add constraint on depopts. [#4002 @rjbou -
  fix #3994]
* Add `format-version` field to all opam files. [#3478 @AltGr] [#3906 @AltGr]
* Clarify pin depend parse error. [#3762 @rjbou]
* Opam file extensions (`x-` fields) enhancement. [#4049 @hannesm]
* Add support for Z3 as a solver backend. [#3845 @AltGr]
* Interleave download actions with build/install actions. [#3777 @Armael]
  [#4083 @rjbou - fix #4080]
* Generalization of the job scheduler: provide separate job pools for different
  subsets of the tasks. [#3778 @AltGr]
* Refactor the return types of `OpamSolution.{apply,resolve_and_apply}`
  [#3781 @Armael]
* Use the scheduler pools to respect the download-jobs parameter.
  [#3791 @AltGr]
* Set the right opam file `format-version` field on upgrade. [#4014 @rjbou]
* Streamline the output from download action. [#3794 @AltGr]
* Use a character that displays better on terminals for download action. [
  #3802 @AltGr]
* Change symbol for download action. [#3862 @AltGr]
* Include the version number in "compilation failed" message. [#4052 @Armael]
* Propagate `--force` remove option to directory tracking revert function.
  [#4094 @rjbou - fix #4091]
* Add `OpamDirTack.string_of_changes` [#4107 @rjbou @hannesm]
* Introduce state `drop` function to replace `ignore (unlock ..)` for more
  lock-type-safety. [#3783 @gasche - #3812 @rjbou]
* Change `OpamStateTypes.switch_state.conf_files `from package_map` to
  `name_map` [#3799 @dra27]
* Fix handling of availability outside of switches. [#3864 @AltGr]
* Sorting formulas function. [#3945 @rjbou]
* Sort formula: fix `compare_formula` & add `compare` [#3960 @rjbou]
* Patch rewrite test. [#3456 @dra27]
* Command errors display: differentiate command not found & permission denied.
  [#3865 @rjbou]
* Factorize option functions in `OpamProcess` [#4016 @nobrakal]
* Use ocaml code for looking up commands in `PATH` [#4072 @Armael]
* Copy files using OCaml code instead of calling to cp or install
  [#4064 @Armael]
* Sort & clean pkg:depend. [#4060 @rjbou - fix #4057]
* Add `of_json` functions & crowbar. [#3776 @gasche]
* JSON (de)serialization for OpamParallel graph. [#3786 @gasche]
* Url: catch failure & specific exception. [#3946 @rjbou]
* Update: don't update installed dev package that is not pinned. [#3947 @rjbou]
* Use `OpamArg` helpers for option. [#4059 @rjbou]
* Steps towards sudo-enabled make install. [#3522 @dra27]
* Port build system to Dune (1.2) [#3618 @dra27]
* Update shell/msvs-detect to 0.4.0. [#3869 @dra27]
* Sort out repository script mode. [#3963 @dra27]
* Preliminary support for Dune 2.0. [#3965 @dra27]
* Update mccs.1.1+11 [#4109 #4146 @MisterDA]
* Fix developer mode option. [#3646 @rjbou]
* Ensure configure generates consistently. [#3935 @dra27]
* Documentation [#3542 @0xflotus] [#3571 @hannesm] [#3780 @gasche]
  [#3944 @tchajed] [#3955 @nbraud] [#4106 @vp2177] [#3863 @dra27] [#3554 @rjbou - fix
  #3540 #2255c #3612 #3606c] [#4058 @rjbou] [#4114 @rjbou @AltGr]

2.0.7:
* opam exec: display command not found message. [#4133 @rjbou - fix #4131]
* Escape Windows paths on manpages. [#4129 @AltGr @rjbou - fix #4100]
* Fix opam installer opam file. [#4058 @rjbou]
* Fix various warnings. [#4132 @rjbou @AltGr - fix #4100]

2.0.6:
* Do not fail if `$HOME/.ccache` is missing. [#3957 @mseri - fix
  https://discuss.ocaml.org/t/dune-1-11-1-compilation-failed/4248]
* Add dune cache as rw. [#4019 @rjbou - fix #4012]
* Check both size and mtime for dirtrack cached entries. [#4038 @hannesm]
* Build man pages with dune. [#3937 @AltGr @dra27]
* make cold: fail if patch or bunzip2 missing. [#4006 @rjbou - fix #3842]
* Documentation [#3999 @maroneze]

2.0.5:
* `opam lint --check-upstream` enables lint checks on archive urls. This
  option lead to download archives to check their checksum. [#3758 @rjbou]
* Lint W59: No url checksum given (if `check-upstream` enabled).
  [#3758 @rjbou]
* Lint E60: Unavailable archive or checksum mismatching (if `check-upstream`
  enabled). [#3758 @rjbou]
* Lint E61: Out-of-scope `with-test` variable in `run-test:` field.
  [#3763 @rjbou - fix AltGr/Camelus/issues/27]
* Lint W58: Restrain warning to filters. [#3871 @rjbou - fix
  ocaml/opam-repository#14280 (comment)]
* Lint E61: Restrain to `run-test:`. [#3860 @rjbou]
* Read jobs variable from `OpamStateConfig` [#3881 @dra27]
* Fix cppo detection. [#3915 @rjbou]
* Documentation [#3809#3891 @dra27]

2.0.4:
* Remove mismatching extra-files: sort list before comparing them.
  [#3744 @rjbou]
* Update source of (version) pinned directory. [#3726 @rjbou - fix #3651]
* Fix `--ignore-pin-depends` with autopin. [#3736 @AltGr]
* Fix pin not installing/upgrading already pinned package. [#3800 @AltGr]
* Fix hg opam1.2 url parsing. [#3754 @rjbou]
* Use `git -c diff.noprefix=false diff`. [#3788/#3628 @Blaisorblade - fix
  #3627]
* Lint W47: Update warning message. [#3753 @rjbou - fix #3738]
* Harmonization of `opam config list` and `opam config var <var>`: resolve
  variable first with switch state (loading it only for package defined
  variables), otherwise, global state. [#3723 @rjbou - fix #3717]
* Considering the possibility that TMPDIR is unset. [#3597 @herbelin - fix
  #3576]
* Unconditionally display MANPATH when fish version is 2.7 or late.
  [#3728 @gregory-nisbet]
* Fix precise tracking mode: missing `to_hex` conversion. [#3796 @rjbou]
* Catch signal to select ones that are really cancelling a blocking state (e.g.
  waiting for a lock to be released). [#3541 @rjbou]
* `opam clean`: ignore errors trying to remove directories.
  [#3732 @kit-ty-kate]
* Documentation [#3731 @MisterDA]

2.0.3:
* On init, retrieve `root is ok` from global options instead of initialization.
  [#3704 @rjbou - fix #3695]
* Regenerate missing environment file. [#3691 @rjbou - fix #3690 #3594]
* Documentation [#3703 @rjbou - fix #3700]

2.0.2:
* Check consistency with opam file when reading lock file to suggest
  regeneration message [#3680 @rjbou - fix #3654]
* Remove pin depends messages. [#3679 @rjbou]
* Upgrade pin depends on pinning. [#3684 @rjbou - fix #3508]
* To avoid lint warning 57 (description error) on 1.2 opam file pinning, add
  auxiliary files (descr, url) before linting. [#3687 @rjbou]
* Don't check hash with --no-checksum on pull_upstream. [#3658 @rjbou - fix
  #3652]
* Lint E52: Fix `light_uninstall` flag. [#3631 @rjbou - fix #3625]
* On init, don't fail if empty compiler given. [#3633 @rjbou - fix #3614]
* Sandbox: make `/var` read-only instead of empty and rw. [#3605 @bobot - fix
  #3604]
* Handle symlinks in bwrap sandbox. [#3661 @mroch - fix #3660]
* Sandbox: Change one-line conditional to `if` statement which was incompatible
  with `set -e`. [#3645 @rjbou - fix #3607]
* Release use of unix sockets on MacOS. [#3663 @silene - fix #3659]
* Fix closure computation in the presence of cycle. [#3670 @AltGr - fix #3662
  #3666]
* Fix some cases of listing coinstallable package. [#3689 @AltGr]
* Extract archived source files of version-pinned packages. [#3610 @rjbou - fix
  #3600]
* Add function to upgrade opam file, including its auxiliary files: descr, url,
  files/. [#3624 @rjbou]
* Set `.out` suffix for `read_command_output` stdout file. [#3644 @rjbou]
  {2.0.2}
* Default opam root is resolved at creation, in order to have the correct
  linked path. [#3681 @rjbou - fix #3622]
* Reinsert and deprecate `alias-of` & `no-autoinstall` option. [#3685 @rjbou -
  fix #3390]
* Updates for OCaml 4.07. [#3474 @dra27]
* Documentation [#3656 @rjbou - fix #3634 #3653 #3639] [#3685 @rjbou - fix
  #3390]

2.0.1:
* Add `opam list --silent` to not write in the output, exit with return
  code 0 if the list is not empty, 1 otherwise. [#3533 @rjbou - fix #3525]
* Fix `opam list --external` [#3558 @rjbou - fix #3557
  ocaml/opam-repository#12677]
* Show command with local opam file returns local file information. Fixes also
  the non 1.2 conversion to 2.0 format of local files with `opam show --raw`.
  [#3536 @rjbou - fix #3423]
* Show command display string fields printed with quotes, as lists.
  [#3368 @rjbou - fix #3365]
* Pin edit: fix editing an opam file without a name field. [#3535 @rjbou]
* Don't execute validation hook if update is empty. [#3490 @hannesm]
* Git: fallback, fetch all repository remotes to get SHA1 with git < 2.1.
  [#3561 @rjbou - fix #3523 #3548]
* Lint E57: A description or a synopsis must be present and non empty.
  [#3581 @rjbou - fix ocaml/opam-repository#12729]
* Lint W58: Advise to use `with-test` and `with-doc` variables if `test`
  and `doc` are present. [#3591 @rjbou - fix #3580 ocaml/opam-repository#12729]
* Add `gtar` as OpenBSD required tool, as tar does not support the `J` flag.
  [#3538 @adamsteen]
* Hash: fallback to internal library in case of openssl error. [#3543 @rjbou -
  fix ocaml/opam-repository#12613]
* Respect user's TMPDIR when invoking bwrap sandbox. [#3487 @3noch]
* Add a way to mount unusual path in bwrap sandbox: introduction of
  `OPAM_USER_PATH_RO` environment variable. [#3540 @ErwanGa]
* opam admin: handle non http backend on repository upgrade: compute hash only
  for http or distant rsync backend [#3596 @rjbou - fix #3590]
* Upgrade to opam 2.0 format overlay opam files of pinned package.
  [#3528 @rjbou - fix #3513]
* Add compiler file translation to opam 2.0 format function. [#3530 @rjbou -
  fix ocaml/opam-repository#12523]
* Tar extract fail error message: if a tar extract fails, it checks the
  presence of underlying commands (bzip2, xz, lzma, gzip) to display the error
  message in verbose mode. [#3502 @rjbou - fix #3497]
* Remove link files only if it exists. [#3519 @rjbou - fix
  ocaml/opam-depext#104]
* Remove GNUism from bootstrap-ocaml.sh [#3481 @dra27 - fix #3480]
* Avoid sed -i, a GNU sed extension, use mv instead [#3603 @hannesm]
* Add patch & bunzip2 check in configure. [#3531 @rjbou - fix #3520]
* Not having wget or curl is now only a hard-error if src_ext/archives doesn't
  contain the archives (i.e. if make -C src_ext cache-archives has not been run)
  which means that this should no longer be a requirement for building with the
  "full" tarball. [#3572 @dra27 - fix #3551]
* C++ test for MCCS is now moved to the correct place and the message as to
  whether the solver will be build should work correctly with --disable-checks.
  Note that not having a C++ compiler is not considered an error if
  --disable-checks is specified because configure is permitted to believe that
  the MCCS library exists even if it couldn't detect it. [#3572 @dra27]

2.0.0
* Fixes and documentation
* Add `opam admin add-hashes` helper to add more secure hashes to the repository

2.0.0~rc3
* Fixes
* Added subcommand `switch link` to link a local switch to a defined one
* Added option `--assume-built` to install an already built pinned package
* Better Windows support
* Obsolete `opam config setup` option

2.0.0~rc2
* Fixes
* Much faster CUDF universe loading
* Much faster `opam env` and similar commands
* Added `opam admin check` for integrity checks on package repositories
* Added the ability to setup scripts on `opam init` from `.opamrc`
* Setup wrappers to sandbox builds by default, based on `bubblewrap` on Linux and `sandbox-exec` on MacOS
* Windows support for many aspects including parallel processes, environment
  variables setup, color console and utf8 (using specific C stubs)
* Better detection of the running shell
* Added shell helpers to automatically sync the environment on every prompt
* Support for selecting different backends if compiled in the `ocaml-mccs` solver lib

2.0.0~rc
* Fixes
* Support compiling on OCaml 4.06.0
* `opam env` and `opam exec` no longer set the `OPAMROOT` or `OPAMSWITCH`
  variables
* Allow in-source package metadata to be gathered in an `opam/` directory

2.0.0~beta6
* Small UI fixes
* Fixed a rare case of looping while processing actions

2.0.0~beta5
* Added timeout support to the solvers (default 1min)
* Added `--unlock-base` to allow changing the compiler of a switch
* Added the `{post}` dependency flag for packages to be installed together, but
  in no specific order. Use it for `base-*` packages.
* Fixed issue with OCaml 4.05.0 and installed programs not found (`Unix.execvpe`
  behaviour changes, https://caml.inria.fr/mantis/view.php?id=7640)
* Added a `pin-depends` field for easier development project dependency
  management and sharing
* Some optimisations to repository loading
* Fixed --best-effort with the built-in solver
* Shorten conflict messages even more
* Added `opam admin add-constraint` to amend a set of reverse dependencies in a
  repository
* New format for `depexts:`, easier to understand and more flexible. Depexts for
  the host can now be inferred by opam
* Optimised search criteria for the built-in solver
* Added a `build-id` variable to identify package builds
* Extend hooks (new variable `installed-files`, new session hooks)
* `opam switch create DIR` now installs packages defined in `DIR`
* Added system-related variables `arch`, `os`, `os-distribution`, `os-family`,
  `os-version`
* Added support for using `opam.locked` files instead of `opam` ones (`--locked`)
* Opam plugins are now made available across switches

2.0.0~beta4
* Building with OCaml < 4.02.3 is no longer supported
* Support compilation with a built-in mccs solver (removing run-time dependency
  to aspcud). Integrated half-working "heuristics" dropped.
* Remove jsonm and transitive uutf dependency.
* Switch build systems to `jbuilder`, including `lib-ext` support
* Allow repeated and or'd arguments to the `list` command
* Many code and build system portability fixes (Windows, BSD)
* Add `switch export --full` to include package definitions
* Add `announce:` and `stamp:` fields to repositories (`repo` files)
* Add a global cache of git objects (greatly speeding up multiple cloning)
* Allow `opam pin URL` without a package name
* Many error handling, messages and corner case fixes
* Updated the versions of dependencies
* Removed the unused `features:` field, and proposal for a new syntax
* More informative exit codes, and documentation thereof

2.0.0~beta3
* (*) Renamed `--soft-request` to `--best-effort`
* Fixed and improved speed of the package file tracking mechanism
* Added `--ignore-constraints-on` to temporarily bypass version constraints on
  some dependencies
* Fields `build-test:`, `build-doc:` are now deprecated, in favor of specifying
  conditions on the `with-test` and `with-doc` variables within the `build:`
  field, and of the new `run-test:` field
* (*) The command-line options have been renamed accordingly to `--with-test`
  and `--with-doc`
* Removed the `opam build` command
* Allow directories in place of package specifications for the `install`,
  `remove`, `upgrade`, `reinstall` and `show` commands. `opam` files can also be
  specified for `install` and `show`
* On local switch creation, check for package definitions and choose a
  compatible compiler if possible
* Add `opam install|remove --destdir` to copy the package's installed files
  somewhere else
* Allow `opam init --config=URL`

2.0~beta2
* Fixes (mainly to `opam build`)
* Faster coinstallability check

2.0~beta
* New, by-hash package archive caching system
* Simpler HTTP repository update
* Allow specification of multiple checksums per file
* Add `opam reinstall --pending`, to handle reinstallations of changed packages
* Support for defining trust anchors and repository validation hooks (for use
  with Conex)
* (*) Added `opam install --working-dir`, removed "mixed mode" for pinned packages
* Added `opam install --soft-request`, a non-failing "do what can be done"
  install mode
* Simplified, better conflict messages
* Added `opam list --coinstallable-with PKG`
* Added command `opam clean`
* Added `opam upgrade --all PKGS`, to do a full upgrade while guaranteeing
  `PKGS` are kept installed
* Allow `&` in conflict version constraints, e.g. `conflicts: "foo" {>= "3" & <
  "4"}`
* Added an `opam admin` command, with various, better organised repository admin
  commands, and remove the `opam-admin` tool
* Added an `opam build` command, to handle `opam` files found in the current
  directory
* Internally upgrade repositories in 1.2 format automatically to 2.0 (on `init`,
  `update` or `repo add`)

2.0~alpha5
* Merge stdout and stderr of child processes by default
* Fixed regression on solver call times
* Added a few shorter command aliases: `opam var` `opam exec`, `opam env` for
  the corresponding `opam config` commands
* (*) Simplified `opam repo` to only use `add` and `remove` in normal use,
  always meaning the current switch (only) if not specified otherwise
* (*) Restrict package names and versions to a reasonable character set
* Added support for SHA256 and SHA512 checksums
* Separated the opam format lexer/parser/printers into a separate
  `opam-file-format` library
* Reporting on package definition file errors only when the file will be used,
  and on by default (rather than all-off by default, and optionally all-on)
* `opam lint` now accept multiple input files
* `opam pin` interface yet improved, allow pinning all at once when a source
  directory contains multiple packages. `opam unpin <dir>` now allowed to cancel
  `opam pin <dir>`
* Updated version of the dose lib dependency
* (*) All patch files used in package definitions are now assumed to apply with
  `-p1`.

2.0~alpha4
* Added pre and post hooks for package command sections; allowed per-switch
  configuration
* Re-packaged the libraries and opam into 7 individual packages
* Convert opam 1.2 files on the fly when pinning
* `opam list` can now match patterns on versions
* Allow switches to be created below arbitrary directories using `opam switch
  create <dir>`. Automatically select a switch found in `$PWD`
* Add `install --reuse-build-dir` to be used together with `--keep-build-dir`
  and allow incremental recompilations
* Add `install --inplace-build` to build locally pinned packages directly in
  their source directory

2.0~alpha3
* (*) Refactored 'opam switch' command, creation of new switches no longer implicit
* (*) Allow per-switch selection of repositories
* Better update of the environment variables across switches or opam roots
* Add `opam install --restore` to recover packages that got removed due to
  errors or interruptions
* Added `synopsis:` and `description:` fields to integrate package descriptions
  in a single package definition file
* Removed the clever hack to skip downloads when uninstalling packages with
  `ocamlfind remove`; this now needs to be explicit through the
  `light-uninstall` flag.
* Provide `opam admin upgrade-format` to migrate package repositories to the new
  format, and create the proper OCaml compiler package wrappers
* Allow initialisation parameters from a .opamrc file, possibly completely
  overriding OCaml and opam.ocaml.org repository defaults

2.0~alpha2
* Extended the `opam lint` command-line options (package descriptions from opam
  metadata, warnings selection)
* Allow to create a new switch with `opam switch import`
* (*) Rewritten, much more flexible `opam list` command, with composable filters and
  output selection
* Delay the removals of packages as much as possible, avoiding most cases of
  mass uninstalled packages after a build failure
* Use a specific `opam` user-agent for downloads
* Remove globalisation of compiler package variables and support for
  `available:` constraints depending on those. Rewrite the repository
  accordingly to use explicit dependencies towards the compiler version.

2.0~alpha
* Changed license to LGPL 2.1 with linking exception, like OCaml (#2573)
* Track files installed by packages for cleaner removal and listing, add `opam
  search --owns-file` (#502, #1215) *this requires packages to properly separate
  build and install*, or unrelated files could get removed on package uninstall.
* Allow command wrappers around package build/install/remove commands to be
  defined in `~/.opam/config`; include sample Linux wrappers to restrict process
  permissions (e.g. ensure `build:` doesn't install)
* (*) Reworked `opam show`, with more fields and the ability to select raw fields
  from the opam file (#2122)
* Dropped ability to compile opam with OCaml earlier than 4.01.0
* Version constraints in `depopts:` allowed again, but with consistent semantics
* Allow mixing filters within dependency constraints
* More flexible `opam pin` command interface
* New internal file-lock handling, less obtrusive and safer
* New `switch export` format, now including local (pinned) package definitions
* No longer uses insecure arguments of curl/wget (#55, #2006, #2460)
* Installed package source and metadata are now handled per-switch, which is
  more reliable
* `opam pin edit` now allows changing version and even URL; better editor
  handling
* Discarded built-in variables based on polling OCaml (they are now defined by
  the compiler package at installation)
* Discarded compiler files, `opam switch` now based on packages with the
  `compiler` flag set
* Extended package configuration files
* Allow initialised opam without switch, initialised switch without compiler.
  Better handling of compiler install failure
* (*) Large API rework, switch and repository state now handled separately, used in
  functional style and avoiding many loads
* Git submodules are now automatically fetched by the git backend
* (*) Package definition files now prioritize `&` higher than `|`, like is most
  common
* (*) `opam list -a` now lists all available packages, even if they can't be
  installed (missing depends...), which is much faster (#2370)
* Added ability to reprint files with reduced diffs (#2363)
* Url and description can now be included within a single package definition
  `opam` file (#2328)
* Internal switch state now all below `<switch-dir>/.opam-switch/`, state in a
  single `switch-state` file (#2340)
* Add a `setenv:` field to package definitions, allowing to export environment
  variables (#2337, #2361)
* Built-in support for alternative solver `mccs` (#2333)
* `opam upgrade pkg` now prompts to install `pkg` if absent (#2327)
* (*) Assume plugin package and exec names start with "opam-" (#2316, #2317)
* Reworked, cleaner and bidirectional file manipulation library (kind of lenses)
  (#2325)
* Allow packages to specify extra remote overlay files within their definition
  files
* Heuristic to detect bad solutions and print a hint when no solver is available
* (*) Proper URL handling with version-control + transport handling (e.g.
  `git+https://`)
* Allow unescaped strings enclosed between `"""` markers in package definition
  files
* Don't rely on '.zip' extension for downloaded archive handling (#2289)
* `opam config` extended with `set`, `unset`, `expand` subcommands, allows
  variables in `exec` argument (#2268)
* `conflict:` field is now handled as a disjunction in all regards (#2267)
* Better handling of concurrent removal/build/install actions (#2161, #2266,
  #2370)
* Allow fields `x-fieldname` in package definition files, for use by external
  tools (#2265)
* Extended, more useful JSON output (including full package failure logs)
  (#2236)
* Use the switch paths that are defined in the switch configuration file (#2185)
* Allow package definition files to reference the package's own variables
  through "%{_:varname}%" (#2184)
* Initialise number of jobs from host's number of processors (#2180)

1.2.2
* Fixed wrong locks being taken during `switch reinstall` (#2051)
* Fixed `config report` that wasn't displaying the external solver (#2059)
* Follow glibc standard on detecting an UTF8 locale (#2065)
* Fixed issues with fish shell init scripts (#2063)
* Restored printing of commands with `--verbose` and `--dry-run`
* More concise printing of conflicts, with accurate version numbers
* Small improvements to the causes of actions
* Fixed issue causing the state cache not to be used on some OSes (OSX) (#2077)
* Added numbers to lint checks, and some new checks
* Restored the handling of a simple path to an `aspcud`-compatible executable
  in variable OPAMEXTERNALSOLVER (#2085)
* Added package universe output to new PEF format for diagnostics
* Prioritise newer versions even when the latest can't be installed (#2109)
* Automatically install plugins on `opam plugin-name` (#2092)
* Fixed a fd leak on solver calls (#2134)
* Accept opam files with errors when no debug or strict options are set, for
  easier format updates
* Add `opam list --resolve` to get dependencies as a consistent set of packages
* Provide the expected checksum to download commands
* Changed return code of `opam list` when no patterns are supplied and the list
  is empty

1.2.1
* Non-system compiler definitions without source are now allowed
* Better handling of compiler "base" packages allows one to move build instructions
  from compiler definitions to packages
* Rewritten action resolution mechanism to be based on atomic actions.
  Actions are not aborted anymore on first failure when there is no
  inter-dependency
* Rewritten parallel command execution engine
* Better display of actions, lots of improved messages
* `opam upgrade pkg` now fails if no new version of `pkg` can be installed
* fixed shell configuration for various shells
* Updated Dose dependency to 3.3
* Fixed behaviour of `opam switch` and related commands when a switch
  is locally set in a shell (through `OPAMSWITCH`)
* Better behaviour on failed `opam switch`
* New pinning mode: when pinning using version-control on a local path and
  without a branch specified, use current file tree, but limited to
  version-tracked files
* Faster and cleaner handling of downloads
* Now compiles with --safe-string on OCaml 4.02, better compatibility handling
* `opam unpin` now accepts multiple arguments
* `opam pin add <pkg>.<version> <target>` is now allowed to specify
  the advertised version
* Fixed bug leading to a bad `CAML_LD_LIBRARY_PATH` when switching from system
* Better `opam lint`, reporting warnings and errors, including format errors
* `opam config setup` now takes `--shell=` instead of `--sh`, `--csh`, `--fish`,
  `--zsh`
* Provisional feature: dependency flag `dev` is accepted (but does nothing)
* Provisional feature: field `features` in opam files implemented (beta), not
  for use in production
* Better definition of the `filter` language within opam files: propagates
  undefined values, bool-to-string converter syntax
* Provisional feature: `verbose` may be specified in package flags
* OPAM git-like plugins (commands of the form opam-xxx) are now searched in the
  correct OPAM path
* ~/.opam/config doesn't refer to OPAM's patch-version anymore, to allow
  downgrading
* Recognise <name>.opam files and directories when pinning a package to source
* Cleaned up debug and verbose messages, allow more control (`-v` can now be
  repeated)
* Pinning URL can now be explicit in the form `VC+URL`, e.g. `git+ssh://`,
  `hg+https://`...
* New flexible way to specify download and solver commands in `~/.opam/config`
  or in variables `OPAMFETCH` and `OPAMEXTERNALSOLVER`
* Lots of bug-fixes

1.2.0
* Handle locally installed self-upgrade opam binary (#1257)
* Added `opam list --depends-on` to show reverse dependencies (#693)
* More consistent checks on user-specified packages (#1241)
* Handle version constraints from the command line (`package>=version`) (#380)
* Output clear and concise messages on non solvable requests (#595, #1238)
* Much better internal parser. File locations in error messages (#1260, #1222)
* Removed dependency on camlp4 (#917)
* Fixed orphan packages handling (installed packages with no upstream) (#1198)
* Solver: optimize default preferences, depending on the solver version. New
  --criteria option (#1208)
* Better PATH modifications handling, add 'opam config env --inplace-path'
  (#1189, #1749)
* Specify variable overrides with environment OPAMVAR_name (#1153)
* Much better overall failsafe behaviour. Error reports on interruption (#1202,
  #1125, #1188...)
* Better action processing, with downloads first (#984)
* Much improved and faster interface with the Cudf solver (#1185, #1179)
* Ask the user to confirm actions whenever non-trivial (#1165)
* Added option --show-actions, made --dry-run simulate actions (#1142)
* Now prints meaningful causes explaining the actions (#1174)
* Fixed the stats displayed after update (#1161)
* Added variables to query ocaml native tools and arch (#979)
* Enable packagers to specify mirrors in url files (#807)
* Cleaned up the command-line interface (#1250, #1170, #1472). Incompatible
  changes:
  - 'opam config exec': takes command args directly rather than as a string (use
    -- for command arguments)
  - 'opam switch import|export': now have a mandatory FILE argument. '-f' no
    longer accepted.
  - 'opam pin' now takes a subcommand 'add', 'remove', 'list' or 'edit'.
  - 'opam config -env': no longer accepted for 'opam config env'
  - '--no-aspcud' is now '--use-internal-solver'.
  - Removed unused `opam config -I`, `opam config {asm,byte}{comp,link}`
  - '-r' isn't accepted anymore for '--root'
* Much extended pinning features, with the ability to use opam files from the
  source, pin packages that don't exist in a repository, fill a local opam
  file from a template, etc.
* Improved the internal solver to handle much larger problems (#1358)
* Use Unix.lockf for more reliable internal repository locks (#1299)
* Large performance improvements (#1363)
* Upgraded external dependencies to dose 3.2.2, ocamlgraph 1.8.5, cmdliner
  0.9.4, cudf 0.7
* Switch export file now include pinning data. Pinned package restored through
  'opam switch import' (#1393)
* Meaningful messages explaining why packages aren't available (#1419, #1398)
* More informative 'opam config list', more complete 'opam config var'
* Added 'opam config cudf-universe' for use in external tools
* opam files: added a 'dev-repo' field, and the experimental 'flags' field
  (#1217, #1472)
* Generate an opam-admin.top to easily apply scripts on a package repository
  (#1454). Provide scripts to ease adding new metadata ('dev-repo', etc.)
* Added 'opam upgrade --fixup' to save the day if your installed package set
  gets inconsistent.
* Fixed some return codes
* Added option to query (recursive) (reverse) dependencies and external
  dependencies to 'opam list
* Fixed opam init for some shells
* OPAM search now includes the 'syntax' and 'libs' fields in the search, as well
  as 'findlib' files
* 'opam source' command to get the package archive or upstream source easily
* Added an 'install' field in opam files, to separate from build
* Added the 'build', 'test' and 'doc' dependency flags to limit the scope
  of some dependencies
* Added Check for common dependencies at init time
* Pinning to a local git directory pins as path, but advertises pinning as git
  will now automatically select the pin kind to 'git' (#1555)
* Fixed init scripts for fish and csh (#952)
* More reliable and faster usage of git branches in the git backend
* Friendlier env variable handling (true/1/yes or false/0/no/"" for true and
  false) (#1608)
* Specify what is not rather than 'already up-to-date' when some packages
  couldn't be upgradedd (#1645)
* Override Make variables in sub-processes (#1617)
* 'opam update' no longer needed after 'opam repo add'
* Attempt to read files in 'permissive mode' when they claim a newer OPAM
  version (#1662)
* Fixed ignore of SIGPIPE in sub-processes (#1681)
* New shell completion scripts
* Added 'opam lint' to perform checks on opam files
* Use the published version of jsonm rather than include it (#1574)
* Changed findlib package name from 'opam' to 'opam-lib'
* Hundreds of smaller fixes and UI improvements

1.1.2
* Rewritten, more compatible build system based on Makefiles (#1362, #1424)

1.1.1
* Fix `opam-admin make <packages> -r` (#990)
* Explicitly prettyprint list of lists, to fix `opam-admin depexts` (#997)
* Tell the user which fields is invalid in a configuration file (#1016)
* Add `OpamSolver.empty_universe` for flexible universe instantiation (#1033)
* Add `OpamFormula.eval_relop` and `OpamFormula.check_relop` (#1042)
* Change `OpamCompiler.compare` to match `Pervasives.compare` (#1042)
* Add `OpamCompiler.eval_relop` (#1042)
* Add `OpamPackage.Name.compare` (#1046)
* Add types `version_constraint` and `version_formula` to `OpamFormula` (#1046)
* Clearer command aliases. Made `info` an alias for `show` and added the alias `uninstall` (#944)
* Fixed `opam init --root=<relative path>` (#1047)
* Display OS constraints in `opam info` (#1052)
* Add a new 'opam-installer' script to make `.install` files usable outside of opam (#1026)
* Add a `--resolve` option to `opam-admin make` that builds just the archives you need
  for a specific installation (#1031)
* Fixed handling of spaces in filenames in internal files (#1014)
* Replace calls to `which` by a more portable call (#1061)
* Fixed generation of the init scripts in some cases (#1011)
* Better reports on package patch errors (#987, #988)
* More accurate warnings for unknown package dependencies (#1079)
* Added `opam config report` to help with bug reports (#1034)
* Do not reinstall dev packages with `opam upgrade <pkg>` (#1001)
* Be more careful with `opam init` to a non-empty root directory (#974)
* Cleanup build-dir after successful compiler installation to save on space (#1006)
* Improved OSX compatibility in the external solver tools (#1074)
* Fixed messages printed on update that were plain wrong (#1030)
* Improved detection of meaningful changes from upstream packages to trigger recompilation

1.1.0 [Oct 2013]
* Fix update of dev packages (#962)
* Add support for zip source archives (#958)
* Add `OPAMCURL` environment variable to control invocation of curl (#960)
* Ensure repository redirects only happen for http remotes (#955)
* Turn malformed package files into warnings instead of hard errors (#957)
* Improve robustness of pinned package update (#949)
* Finish conversion of default repository to <https://opam.ocaml.org> (#948)
* Fix regression in handling archives with no extension (treat them as tar again) (#972)
* Fixed stale archives causing packages to be marked as NEW when they weren't (#945)

1.1.0RC1 [Oct 2013]
* Add `make cold` target to build OPAM without a system OCaml installed (#910)
* More informative error messages from `curl` (#905)
* Document use of `OPAMCOLOR` for optional ANSI coloring
* Add `opam-admin depexts` utility to rewrite OPAM files with external dependencies
* Added `repo` files for repository meta-information
* Added support for repo redirections
* Added scripts for automated testing in Travis
* Fixed bug in opam-admin that could keep not up-to-date archives
* Added an `opam-admin depexts` script to ease handling of external dependencies
* Added the `--deps-only` option to `opam install`
* Fixed upgrade with corner-cases of orphan packages
* Added a `note` display form
* Better handling of external solver failures, and added a `--no-aspcud` option
* Fixed unpinning of some installed packages
* Fixed upgrade of metadata from 1.0 when there are orphan custom compilers

1.1.0-beta [Sept 2013]
* Automatic backup before any operation which might alter the list of installed packages
* Support for arbitrary sub-directories for metadata repositories
* Lots of colors
* New option `opam update -u` equivalent to `opam update && opam upgrade --yes`
* New `opam-admin` tool, bundling the features of `opam-mk-repo` and `opam-repo-check` + new 'opam-admin stats' tool
* New `available`: field in opam files, superseding `ocaml-version` and `os` fields
* Package names specified on the command-line are now understood case-insensitively (#705)
* Fixed parsing of malformed opam files (#696)
* Fixed recompilation of a package when uninstalling its optional dependencies (#692)
* Added conditional post-messages support, to help users when a package fails to install for a known reason (#662)
* Rewrite the code which updates pin et dev packages to be quicker and more reliable
* Add {opam,url,desc,files/} overlay for all packages
* `opam config env` now detects the current shell and outputs a sensible default if no override is provided.
* Improve `opam pin` stability and start display information about dev revisions
* Add a new `man` field in `.install` files
* Support hierarchical installation in `.install` files
* Add a new `stublibs` field in `.install` files
* OPAM works even when the current directory has been deleted
* speed-up invocation of `opam config var VARIABLE` when variable is simple (eg. `prefix`, `lib`, ...)
* `opam list` now display only the installed packages. Use `opam list -a` to get the previous behavior.
* Inverse the depext tag selection (useful for `ocamlot`)
* Add a `--sexp` option to `opam config env` to load the configuration under emacs
* Purge `~/.opam/log` on each invocation of OPAM
* System compiler with versions such as `version+patches` are now handled as if this was simply `version`
* New `OpamVCS` functor to generate OPAM backends
* More efficient `opam update`
* Switch license to LGPL with linking exception
* `opam search` now also searches through the tags
* minor API chanages for `API.list` and `API.SWITCH.list`
* Improve the syntax of filters
* Add a `messages` field
* Add a `--jobs` command line option and add `%{jobs}%` to be used in OPAM files
* Various improvements in the solver heuristics
* By default, turn-on checking of certificates for downloaded dependency archives: use `./configure --disable-certificate-check` to go back to the previous behavior
* Check the md5sum of downloaded archives when compiling OPAM
* Improved `opam info` command (more information, non-zero error code when no patterns match)
* Display OS and OPAM version on internal errors to ease error reporting
* Fix `opam reinstall` when reinstalling a package which is a dependency of installed packages (regression introduced in 0.9.5)
* Export and read `OPAMSWITCH` to be able to call OPAM in different switches
* `opam-client` can now be used in a toplevel
* `-n` now means `--no-setup` and not `--no-checksums` anymore
* Fix support for FreeBSD
* Fix installation of local compilers with local paths endings with `.../ocaml/`
* Fix the contents of `~/.opam/opam-init/variable.sh` after a switch

1.0.0 [Mar 2013]
* Improve the lexer performance (thx to @oandrieu)
* Fix various typos (thx to @chaudhuri)
* Fix build issue (thx to @avsm)

0.9.6 [Mar 2013]
* Fix installation of pinned packages on BSD (thx to @smondet)
* Fix configuration for zsh users (thx to @AltGr)
* Fix loading of `~/.profile` when using dash (eg. in Debian/Ubuntu)
* Fix installation of packages with symbolic links (regression introduced in 0.9.5)

0.9.5 [Mar 2013]
* If necessary, apply patches and substitute files before removing a package
* Fix `opam remove <pkg> --keep-build-dir` keeps the folder if a source archive is extracted
* Add build and install rules using ocamlbuild to help distro packagers
* Support arbitrary level of nested subdirectories in packages repositories
* Add `opam config exec "CMD ARG1 ... ARGn" --switch=SWITCH` to execute a command in a subshell
* Improve the behaviour of `opam update` wrt. pinned packages
* Change the default external solver criteria (only useful if you have aspcud installed on your machine)
* Add support for global and user configuration for OPAM (`opam config setup`)
* Stop yelling when OPAM is not up-to-date
* Update or generate `~/.ocamlinit` when running `opam init`
* Fix tests on *BSD (thx Arnaud Degroote)
* Fix compilation for the source archive

0.9.4 [Feb 2013]
* Disable auto-removal of unused dependencies. This can now be enabled on-demand using `-a`
* Fix compilation and basic usage on Cygwin
* Fix BSD support (use `type` instead of `which` to detect existing commands)
* Add a way to tag external dependencies in OPAM files
* Better error messages when trying to upgrade pinned packages
* Display `depends` and `depopts` fields in `opam info`
* `opam info pkg.version` shows the metadata for this given package version
* Add missing `doc` fields in `.install` files
* `opam list` now only shows installable packages

0.9.3 [Feb 2013]
* Add system compiler constraints in OPAM files
* Better error messages in case of conflicts
* Cleaner API to install/uninstall packages
* On upgrade, OPAM now perform all the remove action first
* Use a cache for main storing OPAM metadata: this greatly speed-up OPAM invocations
* after an upgrade, propose to reinstall a pinned package only if there were some changes
* improvements to the solver heuristics
* better error messages on cyclic dependencies

0.9.2 [Jan 2013]
* Install all the API files
* Fix `opam repo remove repo-name`
* speed-up `opam config env`
* support for `opam-foo` scripts (which can be called using `opam foo`)
* 'opam update pinned-package' works
* Fix 'opam-mk-repo -a'
* Fix 'opam-mk-repo -i'
* clean-up pinned cache dir when a pinned package fails to install

0.9.1 [Jan 2013]
* Use ocaml-re 1.2.0

0.9.0 [Jan 2013]
* add a new `--fake` option to simulate build and installation of packages. Use this option this care, it can easily corrupt the state of OPAM.
* Better messages in case of error
* OPAM proposes better solutions to the user
* support for installed roots and auto-clean of unused packages
* rename `--cores` to `--jobs`
* better error messages for wrong argument of 'opam init'
* show the root causes of actions done by OPAM
* opam import and export now uses -f to specify the filename, and uses stdin and stdout if no filename is specified
* Fix environment initialisation for some corner-cases
* Add a way to specify how to run tests and build documentation for the packages
* Display homepage, authors, doc link, license with 'opam info'
* Improve `opam remove` efficiency when using `ocamlfind` command(s) only
* Git pinning now works with commits/tags/branches
* `opam init` works without preinstalled compiler
* Support for DARCS backends
* Each global command-line flag `xxx` as can be set using the `OPAMxxx` environment variable instead
* Better display of compiler switch (+ read compiler descriptions)
* Clearer error message when trying to pin a non-existing package
* Fix issue with pinning to version number
* Add a `shared` location to be used in OPAM files
* Improve (but break) the command-line interface by using cmdliner

0.8.2 [Dec 2012]
* Fix an issue with `opam reinstall` where packages were reinstalled in reverse order

0.8.1 [Nov 2012]
* Simplify string substitution in OPAM files
* Recompile the installed packages when the system compiler is upgraded
* Fix various regressions in pinned and dev packages introduced in 0.8.0

0.8.0 [Nov 2012]
* Improvements in the solver interface and API
* The solver now use an external SAT-solver (aspcud) if found in the path
* More expressive constraints in optional dependencies
* Clean-up the build directory when build succeeds

0.7.7 [Oct 2012]
* Add an `--alias` global command-line argument to overwrite the default alias value
* Allow more concurrency between no conflicting opam commands
* Upgrade to the latest version of DOSE and CUDF (solver libraries)
* Add repository priorities
* Create the default directories (`bin/`, `lib/` ...) when installing a new compiler

0.7.6 [Oct 2012]
* major internal API refactoring
* repositories are now versionned, and we try to auto-update when possible
* more expressive compiler constraints in opam files

0.7.5 [Oct 2012]
* dependencies can now be expressed by any formula (instead of just CNF)
* It's easier to compose the value of environment variable (ie. to write `%{lwt+ssl:enable}%`)
* Fix regression on init for rsync repositories

0.7.4 [Oct 2012]
* improve `opam pin`: the code is more robust and it is now possible to pin a package to a git repository
* add support for patches per package
* add `opam switch -import file` and `opam switch -export file`

0.7.3 [Sep 2012]
* Better user-message when no solution is found
* Improve the minimality of installed packages

0.7.2 [Sep 2012]
* Fix regression in init introcuced in 0.7.0
* Fix regression in update introduced in 0.7.0

0.7.1 [Sep 2012]
* Remove forgotten debug statement

0.7.0 [Sep 2012]
* report upgrade statistic on update
* do no ask y/n when installing compiler's base packages
* improve opam-mk-repo
* fix `opam search` to be caseless
* ability to filter some commands (depending on some predicates) in opam file
* improvements when packages disappear upstream
* check for ocaml 3.12.1 on configure
* tell the user to unset some potentially dangerous variables when running opam
* fix few git backend issues

0.6.0 [Sep 2012]
* semantics changes in `opam switch`
* solver improvements in case of install and remove
* better error reporting
* fix caching of package archives
* fix `~/.opam/repo/index` priorities

0.5.0 [Sep 2012]
* add opam search
* add opam reinstall
* ability to upgrade only a subset of packages
* lot of bug fixes in the rsync and curl backend
* better `--help` messages
* better information displayed to the user

0.4.0 [Aug 2012]
* better layout of repository files
* (partial) possibility to specify archive checksums
* if the archive is not on ocamlpro.com, download it upstream
* suffix +opam to the versions of archives available on ocamlpro.com
* prompt the user to evaluate `opam config -env` more often
* changes in meta-data aren't picked up by the CURL backen
* more modulare repository system: the 'kind' of repository is no more linked
  to the kind of package archives

0.3.2 [Aug 2012]
* fix regression for `opam switch` introduced in 0.3
* fix deletion of optional dependencies
* support for pinned packages
* fix compilation for ocaml 4.00
* fix compilation for *BSD

0.3.1 [Jul 2012]
* fix regression for `opam install` introduced in 0.3

0.3.0 [Jul 2012]
* improve parallel compilation of packages
* better recovery on compilation/installation errors
* first draft of version pinnig
* fix`'opam config -env` for old shells
* install the latest version of packages when possible
* more robust `opam update` (ie. old files are gc-ed)
* add a (more or less) generic way to install and use topfind

0.2.0 [Jul 2012]
* more robust switch command
* more robust parallel build (not yet activated by default)
* support for compiler-constraints in packages
* new solver heuristics
* improved performance on init with the rsync backend

0.1.0 [Jun 2012]
* Initial version
